

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JSeparator;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.SwingConstants;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.ExpandVetoException;
import javax.swing.tree.TreePath;

import SecureBlackbox.Base.JNI;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.MIME.SBMIME;
import SecureBlackbox.MIME.TElMessagePart;
import SecureBlackbox.PGPMIME.SBPGPMIME;
import SecureBlackbox.SMIME.SBSMIMECore;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeWillExpandListener;
import javax.swing.filechooser.FileNameExtensionFilter;


public class Main extends JDialog implements TreeWillExpandListener, TreeExpansionListener {

	private static final long serialVersionUID = 1L;
	private JTree tree;
	private DefaultMutableTreeNode rootNode;
    private MimeViewer_PlugControl plugFrame;
	private JPanel panel_plug = new JPanel();

    protected DefaultMutableTreeNode fRootOptions = new DefaultMutableTreeNode("Options");
    protected DefaultMutableTreeNode fRootMessages = new DefaultMutableTreeNode("Parsed Messages");
    protected TreeNodeInfoOptions fRootOptionsMIME;
    protected TreeNodeInfoOptions fRootOptionsPGPMIME;
 	protected TreeNodeInfoOptions fRootOptionsSMIME;
 	private JLabel label_caption;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("Mime Viewer demo Application");
		setBounds(100, 100, 862, 475);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmLoadMessageFrom = new JMenuItem("Load Message From File");
		mntmLoadMessageFrom.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				try {
					loadClick();
				} catch (Exception e1) {
					e1.printStackTrace();
				}
			}
		});
		mnFile.add(mntmLoadMessageFrom);
		
		JSeparator separator = new JSeparator();
		mnFile.add(separator);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				exitClick();
			}
		});
		mnFile.add(mntmExit);
		
		JMenu mnEdit = new JMenu("Edit");
		menuBar.add(mnEdit);
		
		JMenuItem mntmDeleteNode = new JMenuItem("Delete Node");
		mntmDeleteNode.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				deleteNodeClick(e);
			}
		});
		mnEdit.add(mntmDeleteNode);
		
		JMenu mnView = new JMenu("View");
		menuBar.add(mnView);
		
		JMenuItem mntmCollapsAll = new JMenuItem("Collaps All");
		mntmCollapsAll.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				collTree(tree);
			}
		});
		mnView.add(mntmCollapsAll);
		
		JMenuItem mntmExpandAll = new JMenuItem("Expand All");
		mntmExpandAll.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				expandTree(tree);
			}
		});
		mnView.add(mntmExpandAll);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About");
		mntmAbout.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				AboutDialog dlg = new AboutDialog();
				dlg.setVisible(true);
			}
		});
		mnHelp.add(mntmAbout);
		
		JPanel panel = new JPanel();
		panel.setPreferredSize(new Dimension(10, 20));
		getContentPane().add(panel, BorderLayout.SOUTH);
		panel.setLayout(null);
		
		JLabel lblReady = new JLabel("Ready");
		lblReady.setBounds(3, 5, 610, 14);
		lblReady.setHorizontalTextPosition(SwingConstants.LEFT);
		lblReady.setHorizontalAlignment(SwingConstants.LEFT);
		panel.add(lblReady);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setPreferredSize(new Dimension(200, 4));
		getContentPane().add(scrollPane, BorderLayout.WEST);
		
		rootNode = new DefaultMutableTreeNode();

		tree = new JTree(rootNode);
		tree.setRootVisible(false);
		tree.setShowsRootHandles(true);
		tree.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent e) {
				treeAfterSelect(e);
			}
		});
		tree.addTreeWillExpandListener(this);
		tree.addTreeExpansionListener(this);
		scrollPane.setViewportView(tree);
		
		JPanel panel_1 = new JPanel();
		getContentPane().add(panel_1, BorderLayout.CENTER);
		panel_1.setLayout(new BorderLayout(0, 0));
		
		JPanel panel_2 = new JPanel();
		panel_2.setBackground(Color.GRAY);
		panel_2.setPreferredSize(new Dimension(10, 30));
		panel_1.add(panel_2, BorderLayout.NORTH);
		
		label_caption = new JLabel("Detail View");
		panel_2.add(label_caption);
		
		panel_1.add(panel_plug, BorderLayout.CENTER);
		panel_plug.setLayout(new BorderLayout(0, 0));

		init();
	}

	protected void loadClick() throws Exception {
       
		String fileName = getOpenFileName();
		
		if ( fileName.length() == 0 )
           return;
		try
		{
			new ElMimeParserTask(fRootMessages, fileName, null);
		} catch (Exception e) {
			e.printStackTrace();
		}
		tree.repaint();
	}

	private String getOpenFileName() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select certificate file");
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Message Files (*.eml;*.msg,*.mht;*.nws)", "eml", "msg", "mht", "nws");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected void deleteNodeClick(MouseEvent e) {
       TreePath p = tree.getSelectionPath();
       if ( p == null ) return;
       TreeNodeInfo nodeInfo = (TreeNodeInfo)p.getLastPathComponent();
       if ( nodeInfo == null ) return;
       DefaultMutableTreeNode node = nodeInfo; 
       if ( ! nodeInfo.getLocked() ){
         if ( ( node.getParent() != null ) && ( node.getParent() != fRootMessages ) ){
           tree.collapseRow(node.getIndex(node.getParent()));
           TreeNodeInfo nullNode = new TreeNodeInfo(TagInfo.tiNull, null);
           nullNode.setText("...");
           node.add(nullNode);
         }
         node.remove(node);
       }
	}

	protected void treeAfterSelect(TreeSelectionEvent e) {
	       TreeNodeInfo nodeInfo = null;
	       MimeViewer_PlugControl plugFrameNew = null;

	       TreePath p = e.getPath();

	       Object node = p.getLastPathComponent();
	       if (node instanceof TreeNodeInfo)
	       {
		       nodeInfo = (TreeNodeInfo)node;
	
		       if ( ( nodeInfo != null ) )
		       {
		         plugFrameNew = nodeInfo.getPlugFrame();
		         if ( plugFrame == plugFrameNew )
		         {
		           if ( plugFrameNew != null )
		           {
		             nodeInfo.UpdatePlugFrame();
		             plugFrameNew.updateUI(); //???
		           }
		         }
		         else
		         {
		           if ( plugFrame != null )
		           {
		             plugFrame.BeforeRemoveParent();
		             plugFrame.setVisible(false);
		             plugFrame = null;
		           }
		           if ( plugFrameNew != null )
		           {
		             plugFrameNew.setVisible(true);
		             panel_plug.add(plugFrameNew, BorderLayout.CENTER);
		             plugFrame = plugFrameNew;
		             nodeInfo.UpdatePlugFrame();
		             plugFrameNew.updateUI(); //???
		           }
		         }
		       }
	
		       if ( plugFrameNew != null )
		         label_caption.setText(plugFrameNew.GetCaption());
		       else
		        label_caption.setText("");
	       }
	       else
	       if ( plugFrame != null )
	       {
	         plugFrame.BeforeRemoveParent();
	         plugFrame.setVisible(false);
	         plugFrame = null;
	       }
	}

	protected void exitClick() {
		dispose();
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		try
		{
	        SBMIME.initialize();
	        SBSMIMECore.initialize();
			SBPGPMIME.initialize();	
			
	        // Initialize SecureBlackbox JNI library. sbbjni32.dll and sbbjni64.dll must be located in java.library.path
	        // You can also call JNI.initialize("full_path_to_dll") method.
	        JNI.initialize();
			
			load();
		} catch(Exception ex) {
			ex.printStackTrace();
		}
	}

	private void clearTree() {
		rootNode.removeAllChildren();
	}
    
	void load() {
		try
		{
			clearTree();

			fRootOptionsMIME = new TreeNodeInfoOptions(TagInfo.tiOptions, new MimeViewer_Options());
			fRootOptionsMIME.setText("MIME");
			fRootOptions.add(fRootOptionsMIME);
			fRootOptionsMIME.setPlugFrame((MimeViewer_PlugControl)fRootOptionsMIME.getTagObj());

			fRootOptionsPGPMIME = new TreeNodeInfoOptions(TagInfo.tiOptions, new MimeViewer_OptionsPGPMime());
			fRootOptionsPGPMIME.setText("PGP/MIME");
			fRootOptions.add(fRootOptionsPGPMIME);
			fRootOptionsPGPMIME.setPlugFrame((MimeViewer_PlugControl)fRootOptionsPGPMIME.getTagObj());

			fRootOptionsSMIME = new TreeNodeInfoOptions(TagInfo.tiOptions, new MimeViewer_OptionsSMime());
			fRootOptionsSMIME.setText("SMIME");
			fRootOptions.add(fRootOptionsSMIME);
			fRootOptionsSMIME.setPlugFrame((MimeViewer_PlugControl)fRootOptionsSMIME.getTagObj());

			rootNode.add(fRootOptions);
			rootNode.add(fRootMessages);
			
			expandTree(tree);

			// initialize viewers
			MimeViewer_Binary vc = new MimeViewer_Binary();
			vc.RegistedPartHandler();

			MimeViewer_SMime sm = new MimeViewer_SMime();
			sm.RegistedPartHandler();
		}
		finally
		{
		}		
	}
	
	private static void expandTree(JTree tree) {	
		tree.setRootVisible(true);

		int row = 0;
	    while (row < tree.getRowCount()) {
	      tree.expandRow(row);
	      row++;
	    }
	    
		tree.setRootVisible(false);
	}

	private static void collTree(JTree tree) {
		tree.setRootVisible(true);
	    int row = 0;
	    while (row < tree.getRowCount()) {
	      tree.collapseRow(row);
	      row++;
	    }
	}

	public void treeWillCollapse(TreeExpansionEvent e)
			throws ExpandVetoException {
		
	}

	public void treeWillExpand(TreeExpansionEvent e)
			throws ExpandVetoException {
		
	       TreePath p = e.getPath();
	       if ( p == null ) return;
	       
	       Object node = p.getLastPathComponent();
	       
	       if (node instanceof TreeNodeInfo)
	       {
		       TreeNodeInfo ni = (TreeNodeInfo)node;
	
		       BeforeExpandHandler h = new BeforeExpandHandler();
		       h.e = e;
		       h.NodeInfo = ni;
		       h.NodeInfoChild = null;
	
		       h.bAllowExpansion = (ni.getChildCount() > 0);
	
		       if ( h.bAllowExpansion )
		       {
		         h.NodeInfoChild = ((TreeNodeInfo)ni.getChildAt(0));
		         if ( (h.NodeInfoChild != null) && (h.NodeInfoChild.getTagInfo() == TagInfo.tiNull) )
		         if (ni.getTagInfo() == TagInfo.tiParsedMessage)
		           {
		             h.md = ((ElMessageDemo)h.NodeInfo.getTagObj());
		             if ( h.md != null ){
		               h.mp = (h.md.getMainPart());
		               h.addMessageInfoForMessagePart(h.mp);
		               ni.remove(h.NodeInfoChild);
		               if ( ni.getChildCount() > 0 )
		                 h.NodeInfoChild = (TreeNodeInfo)ni.getChildAt(0);
		               else
		                 h.NodeInfoChild = null;
		             }
		           }
	
		         if (ni.getTagInfo() == TagInfo.tiHeaders)
		           {
		             h.mp = ((TElMessagePart)h.NodeInfo.getTagObj());
		             if ( ( h.mp != null ) &&
		               ( ( h.mp.getHeader().getFieldsCount() > 0 ) || (h.mp.getHeader().getMailAddressListCount() > 0 ) )
		             ){
		               h.iCount = 0;
		               // MAIL ADDRESSES
		               for ( h.i = 0; h.i < h.mp.getHeader().getMailAddressListCount(); h.i++ ){
		                 h.al = h.mp.getHeader().getMailAddressList(h.i);
		                 if ( (h.al == null) || (h.al.getTotalCount() == 0) )
		                   continue;
	
		                 h.iCount++;
		                 h.NewNode = new TreeNodeInfo(TagInfo.tiFromList, h.al);
		                 h.S = h.al.getFieldName().trim();
		                 if ( h.S.length() == 0 )
		                   h.S = "unnamed_" + h.iCount;
		                 h.NewNode.setText(h.S);
		                 ni.add(h.NewNode);
		                 for ( h.k=0; h.k<h.al.getTotalCount(); h.k++ ){
		                   h.ma = h.al.getAddress(h.k);
		                   if ( h.ma == null )
		                     continue;
		                   if ( h.ma.isAlias() )
		                     h.S = "\"" + h.ma.getAlias() + "\"";
		                   else
		                     h.S = "";
		                   if ( h.ma.isAddress() )
		                     h.S +=  "<" + h.ma.getAddress() + ">";
		                   if ( h.S.length() == 0 )
		                     h.S = "<>";
		                   h.NullNode = new TreeNodeInfo(TagInfo.tiFromList, null);
		                   h.NullNode.setLevel(h.k);
		                   h.NullNode.setText(h.S);
		                   h.NewNode.add(h.NullNode);
		                 }
		                 // GROUPS
		                 for ( h.g =0; h.g<h.al.getGroupsCount(); h.g++){
		                   h.ag = h.al.getGroup(h.g);
		                   if ( h.ag == null )
		                     continue;
		                   h.tmpNode = new TreeNodeInfo(TagInfo.tiGroup, null);
		                   h.tmpNode.setText(h.ag.getName());
		                   h.NewNode.add(h.tmpNode);
		                   //tmpNode
		                   for ( h.ig = 0; h.ig<h.ag.getAddressesCount(); h.ig++){
		                     h.ma = h.ag.getAddress(h.ig);
		                     if ( h.ma == null )
		                       continue;
		                     if ( h.ma.isAlias() )
		                       h.S = "\"" + h.ma.getAlias() + "\"";
		                     else
		                       h.S = "";
		                     if ( h.ma.isAddress() )
		                       h.S += "<" + h.ma.getAddress() + ">";
		                     if ( h.S.length() == 0)
		                       h.S = "<>";
		                     h.NullNode = new TreeNodeInfo(TagInfo.tiFrom, null);
		                     h.NullNode.setText(h.S);
		                     h.NullNode.setLevel(h.ig);
		                     h.tmpNode.add(h.NullNode);
		                   }// of: for h.ig
		                 }//of: h.g
		               }//of: for h.i
		               // HEADERS
		               for ( h.i=0; h.i<h.mp.getHeader().getFieldsCount(); h.i++ ) {
		                 h.f = h.mp.getHeader().getField(h.i);
		                 if ( h.f == null )
		                   continue;
		                 h.iCount++;
		                 h.NewNode = new TreeNodeInfo(TagInfo.tiField, h.f);
		                 h.S = h.f.getName().trim();
		                 if ( h.S.length() == 0 )
		                   h.S = "unnamed_"+h.iCount;
		                 h.NewNode.setText(h.S);
		                 ni.add(h.NewNode);
		                 h.NullNode = new TreeNodeInfo(TagInfo.tiText, null);
		                 //h.NullNode.ImageIndex := NewNode.ImageIndex + 1;
		                 //NullNode.SelectedIndex := NullNode.ImageIndex;
		                 h.NullNode.setText(h.f.getValue());
		                 h.NewNode.add(h.NullNode);
		                 if ( h.f.getComments().length() != 0 ){
		                   h.NullNode = new TreeNodeInfo(TagInfo.tiComment, h.f);
		                   h.NullNode.setText("Comments");
		                   h.NewNode.add(h.NullNode);
		                   h.tmpNode = new TreeNodeInfo(TagInfo.tiText, null);
		                   //tmpNode.ImageIndex := NewNode.ImageIndex + 4;
		                   //tmpNode.SelectedIndex := tmpNode.ImageIndex;
		                   h.tmpNode.setText(h.f.getComments());
		                   h.NullNode.add( h.tmpNode );
		                 }
		                 if ( ProjectOptions.fParamsInTree && (h.f.getParamsCount()>0) ){
		                   h.NullNode = new TreeNodeInfo(TagInfo.tiParamList, h.f);
		                   //NullNode.ImageIndex := NewNode.ImageIndex + 2;
		                   //NullNode.SelectedIndex := NullNode.ImageIndex;
		                   h.NullNode.setText("Params");
		                   h.NewNode.add(h.NullNode);
		                   h.NewNode = h.NullNode;
		                   for ( h.k=0; h.k<h.f.getParamsCount(); h.k++) {
		                     h.NullNode = new TreeNodeInfo(TagInfo.tiParam, null);
		                     h.NullNode.setLevel(h.k);
		                     //h.NullNode.ImageIndex := NewNode.ImageIndex + 1;
		                     //NullNode.SelectedIndex := NullNode.ImageIndex;
		                     h.NullNode.setText(h.f.getParamName(h.k));
		                     h.NewNode.add(h.NullNode);
		                     h.tmpNode = new TreeNodeInfo(TagInfo.tiText, null);
		                     //tmpNode.ImageIndex := NewNode.ImageIndex + 2;
		                     //tmpNode.SelectedIndex := tmpNode.ImageIndex;
		                     h.tmpNode.setText(h.f.getParamValue(h.k));
		                     h.NullNode.add(h.tmpNode);
		                   }//of: for h.k
		                 }
		               }//of: for i:=0
	
		               ni.remove(0);
		               if ( h.iCount>0)
		                 h.NodeInfoChild = (TreeNodeInfo)ni.getChildAt(0);
		               else
		                 h.NodeInfoChild = null;
	
		             }//of: if
		           }
	
		         if (ni.getTagInfo() == TagInfo.tiBody)
		           {
		             h.mp = (TElMessagePart)ni.getTagObj();
		             if ( h.mp != null ) {
		               if ( h.mp.isMultipart() && (h.mp.getPartsCount()>0) ) {
		                 h.iCount = 0;
		                 for ( h.i=0; h.i<h.mp.getPartsCount(); h.i++){
		                   h.mpi = h.mp.getPart(h.i);
		                   if ( h.mpi == null )
		                     continue;
		                   h.iCount++;
		                   h.addPartInfoForMessagePart(h.mpi, h.i+1);
		                 }
		                 getParent(ni).remove(h.NodeInfoChild);
		                 if ( h.iCount>0 )
		                   h.NodeInfoChild = (TreeNodeInfo)ni.getChildAt(0);
		                 else
		                   h.NodeInfoChild = null;
		               }
		               else
		               if ( h.mp.isMessage() )
						try {
							h.addAtachedMessage(h.mp);
						} catch (Exception e1) {
							e1.printStackTrace();
						}
		             }
		           }
	
		         if (ni.getTagInfo() == TagInfo.tiPart || ni.getTagInfo() == TagInfo.tiPartList)
		           {
		             h.mp = (TElMessagePart)ni.getTagObj();
		             h.addPartListInfoForMessagePart(h.mp, -1);
		             getParent(ni).remove(h.NodeInfoChild);
		             if ( ni.getChildCount()  >0 )
		               h.NodeInfoChild = (TreeNodeInfo)ni.getChildAt(0);
		             else
		               h.NodeInfoChild = null;
		           }
	
		         if (ni.getTagInfo() == TagInfo.tiPartHandler)
		           {
		             h.mp = (TElMessagePart)ni.getTagObj();
		             if ( (h.mp != null) && (h.mp.getMessagePartHandler() != null)
		               && (h.mp.getMessagePartHandler().getDecodedPart() != null) )
		             {
		               h.addPartListInfoForMessagePart(h.mp.getMessagePartHandler().getDecodedPart(), -1);
		               getParent(ni).remove(h.NodeInfoChild);
		               if ( ni.getChildCount()>0 )
		                 h.NodeInfoChild = (TreeNodeInfo)ni.getChildAt(0);
		               else
		                 h.NodeInfoChild = null;
		             }
		           }
	
		         if (ni.getTagInfo() == TagInfo.tiPartBodyHandler)
		           {
		             h.mp = (TElMessagePart)ni.getTagObj();
		             if ( (h.mp != null) && (h.mp.getMessageBodyPartHandler() != null)
		               && (h.mp.getMessageBodyPartHandler().getDecodedPart() != null) )
		             {
		               h.addPartListInfoForMessagePart(h.mp.getMessageBodyPartHandler().getDecodedPart(), -1);
		               getParent(ni).remove(h.NodeInfoChild);
		               if ( ni.getChildCount()>0 )
		                 h.NodeInfoChild = (TreeNodeInfo)ni.getChildAt(0);
		               else
		                 h.NodeInfoChild = null;
		             }
		           }
		       }//of: if ( h.bAllowExpansion )
	
		       h.bAllowExpansion = ((h.NodeInfoChild != null) && (h.NodeInfoChild.getTagInfo() != TagInfo.tiNull));
	
		       //e.Cancel = ! h.bAllowExpansion;		
	       }
	}

	private DefaultMutableTreeNode getParent(TreeNodeInfo ni) {
		return ((DefaultMutableTreeNode)ni.getParent());
	}


	public void treeCollapsed(TreeExpansionEvent event) {}

	public void treeExpanded(TreeExpansionEvent event) {}


}
