import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JTabbedPane;
import javax.swing.JLabel;
import java.awt.Dimension;
import javax.swing.SwingConstants;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.Base.SBStrUtils;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.SBX509;
import SecureBlackbox.Base.TElCertificateValidityInfo;
import SecureBlackbox.Base.TElRelativeDistinguishedName;
import SecureBlackbox.Base.TElWinCertStorage;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.Base.TElX509CertificateValidatorResult;
import SecureBlackbox.Base.TSBCertificateValidity;

import java.awt.Font;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Date;


public class MimeViewer_CertDetails extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JLabel dlbSubjectCN;
	private JLabel dlbSubjectOrg;
	private JLabel dlbSubjectOU;
	private JLabel dlbSubjectSN;
	private JLabel dlbSubjectEmail;
	private JLabel dlbIssuerCN;
	private JLabel dlbIssuerOrg;
	private JLabel dlbIssuerOU;
	private JLabel dlbValidFrom;
	private JLabel dlbValidTo;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			MimeViewer_CertDetails dialog = new MimeViewer_CertDetails();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public MimeViewer_CertDetails() {
		setTitle("Certificate Details");
		setBounds(100, 100, 450, 512);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new BorderLayout(0, 0));
		{
			JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
			contentPanel.add(tabbedPane, BorderLayout.CENTER);
			{
				JPanel panel = new JPanel();
				tabbedPane.addTab("General", null, panel, null);
				panel.setLayout(new BorderLayout(0, 0));
				{
					lbGeneralVerdict = new JLabel("Certificate was signed by unknown certificate authority");
					lbGeneralVerdict.setFont(new Font("Tahoma", Font.BOLD, 11));
					lbGeneralVerdict.setHorizontalTextPosition(SwingConstants.CENTER);
					lbGeneralVerdict.setHorizontalAlignment(SwingConstants.CENTER);
					lbGeneralVerdict.setPreferredSize(new Dimension(265, 30));
					panel.add(lbGeneralVerdict, BorderLayout.NORTH);
				}
				{
					lbPrivateKey = new JLabel("Certificate contains private key (also known as Digital ID)");
					lbPrivateKey.setFont(new Font("Tahoma", Font.BOLD, 11));
					lbPrivateKey.setHorizontalAlignment(SwingConstants.CENTER);
					lbPrivateKey.setHorizontalTextPosition(SwingConstants.CENTER);
					lbPrivateKey.setPreferredSize(new Dimension(274, 30));
					panel.add(lbPrivateKey, BorderLayout.SOUTH);
				}
				{
					JPanel panelLeft = new JPanel();
					panelLeft.setPreferredSize(new Dimension(200, 10));
					panel.add(panelLeft, BorderLayout.WEST);
					panelLeft.setLayout(null);
					
					JLabel lblIssuedTo = new JLabel("Issued To");
					lblIssuedTo.setFont(new Font("Tahoma", Font.BOLD, 11));
					lblIssuedTo.setBounds(10, 11, 130, 14);
					panelLeft.add(lblIssuedTo);
					
					JLabel lblCommonName = new JLabel("Common name");
					lblCommonName.setBounds(31, 32, 109, 14);
					panelLeft.add(lblCommonName);
					
					JLabel lblOrganization = new JLabel("Organization");
					lblOrganization.setBounds(31, 52, 130, 14);
					panelLeft.add(lblOrganization);
					
					JLabel lblOrganizationUnit = new JLabel("Organization unit");
					lblOrganizationUnit.setBounds(31, 70, 128, 14);
					panelLeft.add(lblOrganizationUnit);
					
					JLabel lblSerialNumber = new JLabel("Serial number");
					lblSerialNumber.setBounds(31, 89, 109, 14);
					panelLeft.add(lblSerialNumber);
					
					JLabel lblEmail = new JLabel("E-mail");
					lblEmail.setBounds(31, 106, 46, 14);
					panelLeft.add(lblEmail);
					
					JLabel lblIssuedBy = new JLabel("Issued By");
					lblIssuedBy.setFont(new Font("Tahoma", Font.BOLD, 11));
					lblIssuedBy.setBounds(10, 130, 109, 14);
					panelLeft.add(lblIssuedBy);
					
					JLabel lblCommonName_1 = new JLabel("Common name");
					lblCommonName_1.setBounds(31, 155, 109, 14);
					panelLeft.add(lblCommonName_1);
					
					JLabel lblOrganization_1 = new JLabel("Organization");
					lblOrganization_1.setBounds(31, 171, 88, 14);
					panelLeft.add(lblOrganization_1);
					
					JLabel lblOrganizationUnit_1 = new JLabel("Organization unit");
					lblOrganizationUnit_1.setBounds(31, 189, 109, 14);
					panelLeft.add(lblOrganizationUnit_1);
					
					JLabel lblValidity = new JLabel("Validity");
					lblValidity.setFont(new Font("Tahoma", Font.BOLD, 11));
					lblValidity.setBounds(10, 214, 46, 14);
					panelLeft.add(lblValidity);
					
					JLabel lblValidFrom = new JLabel("Valid from");
					lblValidFrom.setBounds(31, 232, 70, 14);
					panelLeft.add(lblValidFrom);
					
					JLabel lblValidTo = new JLabel("Valid to");
					lblValidTo.setBounds(31, 250, 46, 14);
					panelLeft.add(lblValidTo);
				}
				{
					JPanel panelRight = new JPanel();
					panel.add(panelRight, BorderLayout.CENTER);
					panelRight.setLayout(null);
					
					dlbSubjectCN = new JLabel("Sample Name");
					dlbSubjectCN.setBounds(10, 34, 150, 14);
					panelRight.add(dlbSubjectCN);
					
					dlbSubjectOrg = new JLabel("Sample Organization");
					dlbSubjectOrg.setBounds(10, 51, 150, 14);
					panelRight.add(dlbSubjectOrg);
					
					dlbSubjectOU = new JLabel("Sample Organization Unit");
					dlbSubjectOU.setBounds(10, 69, 150, 14);
					panelRight.add(dlbSubjectOU);
					
					dlbSubjectSN = new JLabel("Sample Serial Number");
					dlbSubjectSN.setBounds(10, 88, 150, 14);
					panelRight.add(dlbSubjectSN);
					
					dlbSubjectEmail = new JLabel("Sample E-mail");
					dlbSubjectEmail.setBounds(10, 106, 150, 14);
					panelRight.add(dlbSubjectEmail);
					
					dlbIssuerCN = new JLabel("Sample Name");
					dlbIssuerCN.setBounds(10, 156, 150, 14);
					panelRight.add(dlbIssuerCN);
					
					dlbIssuerOrg = new JLabel("Sample Organization");
					dlbIssuerOrg.setBounds(10, 172, 150, 14);
					panelRight.add(dlbIssuerOrg);
					
					dlbIssuerOU = new JLabel("Sample Organization unit");
					dlbIssuerOU.setBounds(10, 189, 150, 14);
					panelRight.add(dlbIssuerOU);
					
					dlbValidFrom = new JLabel("Sample Valid from");
					dlbValidFrom.setBounds(10, 230, 150, 14);
					panelRight.add(dlbValidFrom);
					
					dlbValidTo = new JLabel("Sample Valid to");
					dlbValidTo.setBounds(10, 247, 150, 14);
					panelRight.add(dlbValidTo);
				}
			}
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}
	
	public static void ValidateCertificate(TElX509Certificate Certificate, TElX509CertificateValidatorResult result)
	{
		TElWinCertStorage Storage;
		if (result.Validity != TSBCertificateValidity.cvSelfSigned) 
		{
			Storage = new TElWinCertStorage();
			Storage.getSystemStores().add("ROOT");
			Storage.getSystemStores().add("CA");
			Storage.getSystemStores().add("MY");
			Storage.getSystemStores().add("SPC");

			try
			{
				TElCertificateValidityInfo  res  = Storage.validate(Certificate, new Date());
				result.Validity = res.Validity; 
				result.Reason = res.Reason;
			}
			catch(Exception ex)
			{
				result.Validity = TSBCertificateValidity.cvStorageError;
			}

			Storage.Free();
		}

		if (result.Validity == TSBCertificateValidity.cvSelfSigned)
		{
			result.Validity = TSBCertificateValidity.cvOk;
			result.Reason = 0;
			if (!Certificate.validate())
			{
				result.Validity = TSBCertificateValidity.cvInvalid;
				result.Reason = SBX509.vrInvalidSignature;
			}
			if (Certificate.getValidFrom().compareTo(new Date()) > 0) 
			{
                result.Reason = result.Reason + SBX509.vrNotYetValid;
				result.Validity = TSBCertificateValidity.cvInvalid;
			}
			if (Certificate.getValidTo().compareTo(new Date()) < 0)
			{
                result.Reason = result.Reason + SBX509.vrExpired;
				result.Validity = TSBCertificateValidity.cvInvalid;
			}
		}
	}

	private TElX509Certificate Cert;
	private JLabel lbGeneralVerdict;
	private JLabel lbPrivateKey;

	public void SetCertificate(TElX509Certificate Certificate, boolean Validated, TSBCertificateValidity Validity, /*SBX509.TSBCertificateValidityReason*/ int Reason)
	{
		Cert = Certificate;

		dlbSubjectCN.setText(GetOIDValue(Cert.getSubjectRDN(), SBConstants.SB_CERT_OID_COMMON_NAME.Data));
		dlbSubjectOrg.setText(GetOIDValue(Cert.getSubjectRDN(), SBConstants.SB_CERT_OID_ORGANIZATION.Data));
		dlbSubjectOU.setText(GetOIDValue(Cert.getSubjectRDN(), SBConstants.SB_CERT_OID_ORGANIZATION_UNIT.Data));
		dlbSubjectEmail.setText(GetOIDValue(Cert.getSubjectRDN(), SBConstants.SB_CERT_OID_EMAIL.Data));
	
		byte[] B = Cert.getSerialNumber();
		dlbSubjectSN.setText(SBUtils.beautifyBinaryString(SBUtils.binaryToString(B), ' '));

		dlbIssuerCN.setText(GetOIDValue(Cert.getIssuerRDN(), SBConstants.SB_CERT_OID_COMMON_NAME.Data));
		dlbIssuerOrg.setText(GetOIDValue(Cert.getIssuerRDN(), SBConstants.SB_CERT_OID_ORGANIZATION.Data));
		dlbIssuerOU.setText(GetOIDValue(Cert.getIssuerRDN(), SBConstants.SB_CERT_OID_ORGANIZATION_UNIT.Data));

		dlbValidFrom.setText(Cert.getValidFrom().toString());
		dlbValidTo.setText(Cert.getValidTo().toString());

		String s;
		if (Cert.getPrivateKeyExists())
			s = "Certificate contains private key (also known as Digital ID)";
		else
			s = "Certificate does NOT contain private key";

		lbPrivateKey.setText(s);

		if ((!Validated) || (Validity == TSBCertificateValidity.cvSelfSigned))
		{
			TElX509CertificateValidatorResult result = new TElX509CertificateValidatorResult(); 
			ValidateCertificate(Cert, result);
			Validity = result.Validity;
			Reason = result.Reason;
		}

		if (Validity == TSBCertificateValidity.cvOk) 
			s = "Certificate is valid";
		else if (Validity == TSBCertificateValidity.cvInvalid)
		{
            if ((SBX509.vrBadData & Reason) > 0)
				s = "Certificate contains invalid data";
            else if ((SBX509.vrInvalidSignature & Reason) > 0)
				s = "Certificate signature doesn't correspond to certificate contents";
            else if ((SBX509.vrUnknownCA & Reason) > 0)
				s = "Certificate was signed by unknown certificate authority";
            else if ((SBX509.vrRevoked & Reason) > 0)
				s = "Certificate has been revoked";
            else if ((SBX509.vrNotYetValid & Reason) > 0)
				s = "Certificate was issued for a later starting date";
            else if ((SBX509.vrExpired & Reason) > 0)
				s = "Certificate has already expired";
			else
				s = "Certificate is NOT valid";
		}
		else if (Validity == TSBCertificateValidity.cvStorageError)
			s = "Certificate could not be validated";

		lbGeneralVerdict.setText(s);
	}

	public void SetCertificate(TElX509Certificate Certificate)
	{
		SetCertificate(Certificate, false, TSBCertificateValidity.cvOk, 0);
	}
	
	public static String GetStringByOID(byte[] S)
	{
		if (SBUtils.compareContent(S, (byte[])SBConstants.SB_CERT_OID_COMMON_NAME.Data))
			return "CommonName";
		else
			if (SBUtils.compareContent(S, (byte[])SBConstants.SB_CERT_OID_COUNTRY.Data))
			return "Country";
		else
			if (SBUtils.compareContent(S, (byte[])SBConstants.SB_CERT_OID_LOCALITY.Data))
			return "Locality";
		else
			if (SBUtils.compareContent(S, (byte[])SBConstants.SB_CERT_OID_STATE_OR_PROVINCE.Data))
			return "StateOrProvince";
		else
			if (SBUtils.compareContent(S, (byte[])SBConstants.SB_CERT_OID_ORGANIZATION.Data))
			return "Organization";
		else
			if (SBUtils.compareContent(S, (byte[])SBConstants.SB_CERT_OID_ORGANIZATION_UNIT.Data))
			return "OrganizationUnit";
		else
			if (SBUtils.compareContent(S, (byte[])SBConstants.SB_CERT_OID_EMAIL.Data))
			return "Email";
		else
			return "UnknownField";			
	}

	public static String GetOIDValue(TElRelativeDistinguishedName RDN, byte[] S)
	{
		String t = "";
		int iCount = RDN.getCount();
		for (int i = 0; i < iCount; i++)
		{
			if (SBUtils.compareContent(RDN.getOID(i), S))
			{
				if (t != "")
					t += " / ";

				t += SBStrUtils.utf8ToStr(RDN.getValue(i));
			}
		}

		return t;
	}
}
