import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class PanelSelectSourceDescriptor extends WizardPanelDescriptor implements ActionListener {
    
    public static final String IDENTIFIER = "SOURCE_PANEL";
    
    public static PanelSelectSource panel;
    
    public PanelSelectSourceDescriptor() {
        
        panel = new PanelSelectSource();
        panel.addFieldsListener(this);
        
        setPanelDescriptorIdentifier(IDENTIFIER);
        setPanelComponent(panel);
    }
    
    public Object getNextPanelDescriptor() {
    	if (PanelOperationSelect.isProtect())
    		return PanelProtectionDescriptor.IDENTIFIER;
    	return PanelProcessUndoProtectionDescriptor.IDENTIFIER;
    }
    
    public Object getBackPanelDescriptor() {
        return PanelSelectFilesDescriptor.IDENTIFIER;
    }

    public void aboutToDisplayPanel(){
    	setNextButtonAccordFields();
    	panel.setHeadText();
    }
   
	private void setNextButtonAccordFields() {
		getWizard().setNextFinishButtonEnabled(panel.isFieldsValidated());
		
	}

	public void actionPerformed(ActionEvent e) {
    	setNextButtonAccordFields();
    }
}
