import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.border.TitledBorder;

import SecureBlackbox.PGP.TElPGPKeyring;
import SecureBlackbox.PGP.TElPGPSecretKey;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class SelectKeyDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private boolean isOk;
	private JList<ListData> list;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			SelectKeyDialog dialog = new SelectKeyDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public SelectKeyDialog() {
		setTitle("Key selection");
		setBounds(100, 100, 419, 404);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblPleaseSelect = new JLabel("Please select a key");
			lblPleaseSelect.setBounds(10, 11, 327, 14);
			contentPanel.add(lblPleaseSelect);
		}
		
		IconListRenderer r = new IconListRenderer();
		list = new JList<ListData>(new DefaultListModel<ListData>());
		list.setCellRenderer(r);
		list.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		list.setBounds(10, 36, 391, 284);
		contentPanel.add(list);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public void init(TElPGPKeyring keys) {
		int i;
		list.removeAll();
		for(i = 0; i < keys.getSecretCount(); i++) 
			addItem(keys, i);
	}

	private void addItem(TElPGPKeyring keys, int i) {
		DefaultListModel<ListData> model = ((DefaultListModel<ListData>)list.getModel());
		model.add(model.size(), new ListData(keys, i));
	}
	
	public int getKeysSelectedItemsCount() {
		return list.getSelectedIndices().length;
	}

	public TElPGPSecretKey getKeysSelectedItemsTag(int i) {
		ListData data = list.getModel().getElementAt(i);
		return data.Keys.getSecretKeys(data.Index);
		
	}
	
	public boolean isOK() {
		return isOk;
	}
}