import java.util.Vector;

import javax.swing.table.AbstractTableModel;


public class DocTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int PROP_INDEX = 0;
	public static final int VAL_INDEX = 1;
	
	protected Vector<DocDataRow> dataVector = new Vector<DocDataRow>();
	
    protected String[] columnNames = {
    		"Property", 
    		"Value" 
    };
    
    public void addRow(String prop, String value) {
    	dataVector.addElement(new DocDataRow(prop, value));
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        DocDataRow record = (DocDataRow)dataVector.get(row);
        switch (col) {
        	case PROP_INDEX:
        		return record.Property;
        	case VAL_INDEX:
	        	 return record.Value;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
		fireTableDataChanged();
	}
}