

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import java.io.*;
import java.util.*;

import javafx.scene.control.Dialog;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.HTTPClient.*;
import SecureBlackbox.PDF.*;
import SecureBlackbox.PKIPDF.*;
import SecureBlackbox.LDAP.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTable tableDocProps;
	private JTable tableSign;
	private JTable tableRev;

    private AddSigDialog m_frmAddSig = null;
    private UpdSigDialog m_frmUpdSig = null;

    private TElPDFDocument m_CurrDoc = null;
    private String m_CurrOrigFile = "";
    private String m_CurrTempFile = "";
    private TElFileStream m_CurrStream = null;
    TElPDFPublicKeyRevocationInfo m_DocRevInfo = new TElPDFPublicKeyRevocationInfo();
    TElPDFPublicKeyRevocationInfo m_LocalRevInfo = new TElPDFPublicKeyRevocationInfo();
    TElMemoryCertStorage m_TrustedCerts = new TElMemoryCertStorage();
    TElMemoryCRLStorage m_KnownCRLs = new TElMemoryCRLStorage();
    TElPDFAdvancedPublicKeySecurityHandler m_Handler = null;
    TElMemoryCertStorage m_CertStorage = new TElMemoryCertStorage();
    TElHTTPTSPClient m_TspClient = new TElHTTPTSPClient();
    TElHTTPSClient m_HttpClient = new TElHTTPSClient();
    TElStringList m_CertValidationLog = new TElStringList();
	private DocTableModel docModel;
	private SignTableModel signModel;
	private RevTableModel revModel;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("EldoS PAadES demo");
		setBounds(100, 100, 718, 488);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblDocumentProperties = new JLabel("Document properties");
		lblDocumentProperties.setBounds(10, 11, 225, 14);
		contentPanel.add(lblDocumentProperties);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 31, 690, 104);
		contentPanel.add(scrollPane);
		
		docModel = new DocTableModel();
		tableDocProps = new JTable(docModel);
		tableDocProps.setFillsViewportHeight(true);
		scrollPane.setViewportView(tableDocProps);
		
		JLabel lblSignatures = new JLabel("Signatures");
		lblSignatures.setBounds(10, 146, 184, 14);
		contentPanel.add(lblSignatures);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(10, 163, 582, 104);
		contentPanel.add(scrollPane_1);
		
		signModel = new SignTableModel();
		tableSign = new JTable(signModel);
		tableSign.setFillsViewportHeight(true);
		scrollPane_1.setViewportView(tableSign);
		
		JButton btnRevalidate = new JButton("Revalidate");
		btnRevalidate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				revClick();
			}
		});
		btnRevalidate.setBounds(602, 163, 98, 23);
		contentPanel.add(btnRevalidate);
		
		JButton btnShowValidationLog = new JButton("Show Log");
		btnShowValidationLog.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showLogClick();
			}
		});
		btnShowValidationLog.setBounds(602, 194, 98, 23);
		contentPanel.add(btnShowValidationLog);
		
		JLabel lblRevocationInformationcheck = new JLabel("Revocation information (select the trusted certificates):");
		lblRevocationInformationcheck.setBounds(10, 278, 439, 14);
		contentPanel.add(lblRevocationInformationcheck);
		
		JScrollPane scrollPane_2 = new JScrollPane();
		scrollPane_2.setBounds(10, 295, 582, 104);
		contentPanel.add(scrollPane_2);
		
		revModel = new RevTableModel();
		tableRev = new JTable(revModel);
		tableRev.setFillsViewportHeight(true);
		scrollPane_2.setViewportView(tableRev);
		
		JButton btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addRevClick();
			}
		});
		btnAdd.setBounds(602, 295, 98, 23);
		contentPanel.add(btnAdd);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton btnAddSignature = new JButton("Add signature");
				btnAddSignature.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						addSignClick();
					}
				});
				buttonPane.add(btnAddSignature);
			}
			{
				JButton btnUpdate = new JButton("Update signature");
				btnUpdate.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						updateSignClick();
					}
				});
				btnUpdate.setActionCommand("OK");
				buttonPane.add(btnUpdate);
				getRootPane().setDefaultButton(btnUpdate);
			}
			{
				JButton cancelButton = new JButton("Close");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		init();
	}

	protected void updateSignClick() {
        if (tableSign.getSelectedRowCount() > 0)
        {
            TElPDFSignature sig = (TElPDFSignature)signModel.getTag(tableSign.getSelectedRow());
            if ((sig.getHandler() instanceof TElPDFAdvancedPublicKeySecurityHandler) &&
                ((((TElPDFAdvancedPublicKeySecurityHandler)sig.getHandler()).getPAdESSignatureType() == TSBPAdESSignatureType.pastEnhanced) ||
                (((TElPDFAdvancedPublicKeySecurityHandler)sig.getHandler()).getPAdESSignatureType() == TSBPAdESSignatureType.pastDocumentTimestamp)))
            {
            	
            	m_frmUpdSig.setModal(true);
            	m_frmUpdSig.setVisible(true);
                if (m_frmUpdSig.isOK())
                {
                    try
                    {
                        try
                        {
                            TElPDFAdvancedPublicKeySecurityHandler handler = (TElPDFAdvancedPublicKeySecurityHandler)sig.getHandler();
                            handler.setAutoCollectRevocationInfo(m_frmUpdSig.getAutoCollectRevInfo());
                            handler.setIgnoreChainValidationErrors(m_frmUpdSig.getIgnoreChainValidationErrors());
                            if (m_frmUpdSig.getIncludeLocalRevInfo())
                            {
                                handler.getCustomRevocationInfo().assign(m_LocalRevInfo, false);
                            }

                            // updating the signature
                            try
                            {
                                sig.update();
                            }
                            catch (Exception ex)
                            {
                                showMessage("Signature updating failed");
                                return;
                            }

                            // adding document time stamp
                            int idx = m_CurrDoc.addSignature();
                            sig = m_CurrDoc.getSignatureEntry(idx);
                            m_Handler.setPAdESSignatureType(TSBPAdESSignatureType.pastDocumentTimestamp);
                            sig.setHandler(m_Handler);
                            m_TspClient.setHTTPClient(m_HttpClient);
                            m_TspClient.setURL(m_frmUpdSig.getTSPURL());
                            m_Handler.setTSPClient(m_TspClient);

                            // saving the document
                            sig.setSigningTime(new Date());
                            if (showConfirmMessage("Everything has been prepared for signature updating. Update signature and write changes to the document?", "Confirmation"))
                            {
                                CloseCurrentDocument(true);
                                showMessage("Signature updating succeeded");
                            }
                            else
                            {
                                CloseCurrentDocument(false);
                                showMessage("Signature updating cancelled");
                            }
                        }
                        catch (Exception ex)
                        {
                            showMessage("Signature updating failed: " + ex.getMessage());
                        }
                    }
                    finally
                    {
                        Close();
                    }
                }
            }
            else
            {
                showMessage("The selected signature cannot be updated");
            }
        }
        else
        {
            showMessage("No signature selected");
        }	
	}

	protected void addSignClick() {
		m_frmAddSig.setModal(true);
		m_frmAddSig.setVisible(true);
		if (m_frmAddSig.isOK())
        {
            try
            {
                try
                {
                    int idx = m_CurrDoc.addSignature();
                    TElPDFSignature sig = m_CurrDoc.getSignatureEntry(idx);
                    sig.setHandler(m_Handler);
                    sig.setInvisible(!m_frmAddSig.getVisibleChecked());
                    m_CertStorage.clear();
                    m_CertStorage.add(m_frmAddSig.getCert(), true);
                    m_Handler.setCertStorage(m_CertStorage);
                    if (m_frmAddSig.getEnhancedSig())
                    {
                        m_Handler.setPAdESSignatureType(TSBPAdESSignatureType.pastEnhanced);
                    }
                    else
                    {
                        m_Handler.setPAdESSignatureType(TSBPAdESSignatureType.pastBasic);
                    }

                    m_Handler.setCustomName("Adobe.PPKMS"); // article: http://www.eldos.com/security/articles/2992.php
                    PrepareValidation(m_Handler);

                    if (m_frmAddSig.getRequestTimestamp())
                    {
                        m_TspClient.setHTTPClient(m_HttpClient);
                        m_TspClient.setURL(m_frmAddSig.getTSAURL());
                        m_TspClient.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_SHA1);
                        m_Handler.setTSPClient(m_TspClient);
                    }
                    else
                    {
                        m_Handler.setTSPClient(null);
                    }
                    if (m_frmAddSig.getIncludeLocalRevInfo())
                    {
                        m_Handler.getCustomRevocationInfo().assign(m_LocalRevInfo, true);
                    }
                    m_Handler.setAutoCollectRevocationInfo(m_frmAddSig.getAutoCollectRevInfoChecked());
                    m_Handler.setIgnoreChainValidationErrors(m_frmAddSig.getIgnoreChainValidationErrorsChecked());
                    sig.setSigningTime(new Date());
                    if (showConfirmMessage("Everything has been prepared for signing. Sign and write changes to the document?", "Confirmation"))
                    {
                        CloseCurrentDocument(true);
                        showMessage("Signing succeeded");
                    }
                    else
                    {
                        CloseCurrentDocument(false);
                        showMessage("Signing cancelled");
                    }
                }
                catch (Exception ex)
                {
                    showMessage("Signing failed: " + ex.getMessage());
                }
            }
            finally
            {
                Close();
            }
        }		
	}

	private boolean showConfirmMessage(String msg, String cap) {
		return (JOptionPane.showConfirmDialog(this, msg, cap, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION);
	}
	
	private void Close() {
		onClose();
		dispose();
	}

	protected void addRevClick() {
		String fileName = getCertFileName();
        if (fileName.compareTo("") != 0)
        {
            try
            {
                int r = 0;
               
                int FilterIndex = getFilterIndex(fileName);
                switch (FilterIndex)
                {
                    case 1: // certificate
                        TElX509Certificate cert = new TElX509Certificate();
                        String pass = "";
                        if (extension(fileName).toLowerCase().compareTo(".pfx") == 0)
                        {
                                pass = requestPassword();
                        }
                        r = cert.loadFromFileAuto(fileName, pass);
                        if (r != 0)
                        {
                            throw new Exception("Failed to load certificate, error " + r);
                        }
                        m_LocalRevInfo.getCertificates().add(cert, true);
                        break;
                    case 2: // CRL
                        TElCertificateRevocationList crl = new TElCertificateRevocationList();
                        FileInputStream f = new FileInputStream(fileName);
                        try
                        {
                            r = crl.loadFromStream(f, 0);
                            if (r != 0)
                            {
                                throw new Exception("Failed to load CRL, error " + r);
                            }
                            r = m_LocalRevInfo.addCRL();
                            m_LocalRevInfo.getCRL(r).assign(crl);
                        }
                        finally
                        {
                            f.close();
                        }
                        break;
                    case 3: // OCSP response
                    	TElFileStream tf = new TElFileStream(fileName, "r", true);
                        try
                        {
                            byte[] resp = new byte[(int) tf.getLength()];
                            tf.read(resp, 0, resp.length);
                            r = m_LocalRevInfo.addOCSPResponse();
                            m_LocalRevInfo.setOCSPResponse(r, resp);
                        }
                        finally
                        {
                            tf.Destroy();
                        }
                        break;
                }
            }
            catch (Exception ex)
            {
                showErrorMessage("Load failed: " + ex.getMessage());
            }
            RefreshRevInfo();
        } 
	}
	
    private String getCertFileName() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select certificate file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( PFX | CRL | OCSP )-encoded certificate", "pfx", "crl", "*");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	private String requestPassword() {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Please provide a password for the certificate", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}

	private int getFilterIndex(String certFileName) {
		String ext = extension(certFileName).toLowerCase();
		if (ext.compareTo("pfx") == 0) return 1;
		if (ext.compareTo("crl") == 0) return 2;
		return 3;
	}

	public String extension(String fullPath) {
	    int dot = fullPath.lastIndexOf(".");
	    return fullPath.substring(dot + 1);
	}

	protected void revClick() {
        if (tableSign.getSelectedRowCount() > 0)
        {
        	int selIndex = tableSign.getSelectedRow();
        	TElPDFSignature tag = signModel.getTag(selIndex);
            SignDataRow row = RefreshSignatureInfo(tag, true);
            signModel.change(row, selIndex);
        }
        else
        {
            showMessage("No signature selected");
        }		
	}

	private void init() {
        #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
        SBUtils.setLicenseKey("<put the key here>");
		
		// These five are used to make CertificateValidator check CRL and OCSP properly via HTTP and LDAP, and to retrieve CA Certificates automatically
		SBHTTPCertRetriever.registerHTTPCertificateRetrieverFactory();
		SBHTTPCRL.registerHTTPCRLRetrieverFactory();
		SBHTTPOCSPClient.registerHTTPOCSPClientFactory();
		SBLDAPCertRetriever.registerLDAPCertificateRetrieverFactory();
		SBLDAPCRL.registerLDAPCRLRetrieverFactory();

        JNI.initialize();
        
        SBPDF.initialize();
        SBPAdES.initialize();
        SBPDFSecurity.initialize();
        
        m_Handler = new TElPDFAdvancedPublicKeySecurityHandler();
        m_frmAddSig = new AddSigDialog();
        m_frmUpdSig = new UpdSigDialog();
        
        try {
	                	
			onShow();
		} catch (Exception e) {
			showErrorMessage(e.getMessage());
			e.printStackTrace();
		}
	}

	private void onShow() throws Exception {
		String fileName = getOpenFileName();
        if (fileName.compareTo("") != 0)
        {
            PrepareTemporaryFile(fileName);
            try
            {
                m_CurrDoc = new TElPDFDocument();
                try
                {
                    m_CurrDoc.setOwnActivatedSecurityHandlers(true);
                    m_CurrDoc.open(m_CurrStream);
                    ExtractRevInfo();
                    RefreshView();
                }
                catch (Exception exc)
                {
                    m_CurrDoc = null;
                    throw exc;
                }
            } catch(Exception ex) {
                DeleteTemporaryFile(false);
                throw ex;
            }
        }
        else
        {
            Close();
        }
	}
	
	private void onClose() {
        CloseCurrentDocument(false);
	}
	
    private void RefreshView()
    {
        RefreshDocumentInfo();
        RefreshSignaturesInfo();
        RefreshRevInfo();
    }

    private void RefreshDocumentInfo()
    {
        clearDocTable();
        docModel.addRow("Filename", m_CurrOrigFile);
        docModel.addRow("Pages", m_CurrDoc.getPageInfoCount() + "");
        docModel.addRow("Attachments", m_CurrDoc.getAttachedFileCount() + "");
        if (m_CurrDoc.getSigned()) 
        {
        	docModel.addRow("Signed", "yes");
        }
        else
        {
        	docModel.addRow("Signed", "no");
        }
        docModel.addRow("Empty signature fields", m_CurrDoc.getEmptySignatureFieldCount() + "");
    }

    private void clearDocTable() {
    	docModel.clear();
	}

	private SignDataRow RefreshSignatureInfo(TElPDFSignature sig, boolean revalidate)
    {
        SignDataRow row = new SignDataRow();
        
        TElPDFAdvancedPublicKeySecurityHandler handler = null;
        if (sig.getHandler() instanceof TElPDFAdvancedPublicKeySecurityHandler)
        {
            handler = (TElPDFAdvancedPublicKeySecurityHandler)sig.getHandler();
            if (handler.getPAdESSignatureType() == TSBPAdESSignatureType.pastBasic)
            {
                row.Type = "Basic";
            }
            else if (handler.getPAdESSignatureType() == TSBPAdESSignatureType.pastEnhanced)
            {
                row.Type = "Enhanced (long-term)";
            }
            else if (handler.getPAdESSignatureType() == TSBPAdESSignatureType.pastDocumentTimestamp)
            {
                row.Type = "Document timestamp";
            }
            else
            {
                row.Type = "Unknown";
            }
        }
        else if (sig.getHandler() instanceof TElPDFPublicKeySecurityHandler)
        {
            row.Type = "Standard";
        }
        else
        {
            row.Type = "Unknown";
        }
        row.Name = sig.getSignatureName();
        if (handler != null)
        {
            String s = "Issuer: " + handler.getCMS().getSignature(0).getSigner().getIssuer().saveToDNString() + ", S/N: " +
                SBUtils.binaryToString(handler.getCMS().getSignature(0).getSigner().getSerialNumber());
            row.Author = s;
            if (handler.getTimestampCount() > 0)
            {
                row.SignTime = handler.getTimestamp(0).getTime().toString() + " " + handler.getTimestamp(0).getTime().toString();
                row.Timestamped = "yes";
            }
            else if (handler.getPAdESSignatureType() == TSBPAdESSignatureType.pastDocumentTimestamp)
            {
                row.SignTime = handler.getDocumentTimestamp().getTime().toString() + " " + handler.getDocumentTimestamp().getTime().toString();
                row.Timestamped = "yes";
            }
            else
            {
                row.SignTime = sig.getSigningTime().toString() + " " + sig.getSigningTime().toString();
                row.Timestamped = "no";
            }
            s = "";
            String t = "";
            if ((handler.getValidationDetails() == TSBCMSAdvancedSignatureValidity.casvUnknown) || revalidate)
            {
                PrepareValidation(handler);
                try
                {
                    sig.validate();
                    if (!sig.isDocumentSigned())
                        t = "Signature does not cover the entire document";
                }
                catch (Exception e)
                {
                    t = e.getMessage();
                }
            }
            
            TSBCMSAdvancedSignatureValidity d = handler.getValidationDetails();

            if (d == TSBCMSAdvancedSignatureValidity.casvValid) 
                s = "Valid";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvSignatureCorrupted) 
                s = "Signature corrupted";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvSignerNotFound) 
                s = "Signer not found";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvIncompleteChain) 
                s = "Incomplete chain";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvBadCountersignature) 
                s = "Bad countersignature";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvBadTimestamp) 
                s = "Bad timestamp";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvCertificateExpired) 
                s = "Certificate expired";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvCertificateRevoked) 
                s = "Certificate revoked";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvCertificateCorrupted) 
                s = "Certificate corrupted";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvUntrustedCA) 
                s = "Untrusted CA";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvRevInfoNotFound) 
                s = "Revocation information not found";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvTimestampInfoNotFound)
                s = "Timestamp information not found";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvFailure) 
                s = "General failure";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvCertificateMalformed) 
                s = "Certificate malformed";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvUnknown) 
                s = "Unknown";
                
            if (d == TSBCMSAdvancedSignatureValidity.casvChainValidationFailed)
                s = "Chain validation failed";
                    
            row.Validity = s + ", " + t;
        }
        else
        {
            row.Author = sig.getAuthorName();
            row.SignTime = sig.getSigningTime().toString() + " " + sig.getSigningTime().toString();
            row.Timestamped = "N/A";
            row.Validity = "N/A";
        }
        row.Tag = sig;
        
        return row;
    }

    private void PrepareValidation(TElPDFAdvancedPublicKeySecurityHandler handler)
    {
        m_TrustedCerts.clear();
        for (int i = 0; i < tableRev.getRowCount(); i++)
        {
        	Object tag = revModel.getTag(i);
        	boolean checked = (tableRev.getSelectedRow() == i);
            if ((tag instanceof TElX509Certificate) && (checked))
            {
                m_TrustedCerts.add((TElX509Certificate)tag, false);
            }
            else if (tag instanceof TElCertificateRevocationList)
            {
                m_KnownCRLs.add((TElCertificateRevocationList)tag);
            }
        }
        handler.setOnCertValidatorPrepared(new TSBPDFCertValidatorPreparedEvent(onCertValidatorPrepared));
        handler.setOnCertValidatorFinished(new TSBPDFCertValidatorFinishedEvent(onCertValidatorFinished));
        int k = m_CertValidationLog.indexOfObject(handler);
        if (k >= 0)
        	m_CertValidationLog.remove(k);
    }
    
    private void ShowMessageDialogWithScroll(String msg)
    {
		// create a JTextArea
	    JTextArea textArea = new JTextArea(30, 80);
	    textArea.setText(msg);
	    textArea.setEditable(false);
	       
	    // wrap a scrollpane around it
	    JScrollPane scrollPane = new JScrollPane(textArea);
	       
	    // display them in a message dialog
	    JOptionPane.showMessageDialog(new JFrame("Certificate validation log"), scrollPane);
    }
        
	protected void showLogClick() {
        if (tableSign.getSelectedRowCount() > 0)
        {
        	int selIndex = tableSign.getSelectedRow();
        	TElPDFSignature tag = signModel.getTag(selIndex);
        	int k = m_CertValidationLog.indexOfObject(tag.getHandler());
        	if (k >= 0)
        		ShowMessageDialogWithScroll(m_CertValidationLog.getString(k));
        	else
        		showMessage("No signature selected");
        }
        else
        {
            showMessage("No signature selected");
        }		
	}
    
    TSBPDFCertValidatorFinishedEvent.Callback onCertValidatorFinished = new TSBPDFCertValidatorFinishedEvent.Callback() {
		
		@Override
		public void tsbpdfCertValidatorFinishedEventCallback(TObject arg0,
				TElX509CertificateValidator arg1, TElX509Certificate arg2,
				TSBCertificateValidity arg3, int arg4) {
			int k = m_CertValidationLog.indexOfObject(arg0);
			if (k >= 0)
				m_CertValidationLog.setString(k, m_CertValidationLog.getString(k) + "\n" + arg1.getInternalLogger().getLog().getText());
			else
				m_CertValidationLog.addObject(arg1.getInternalLogger().getLog().getText(), arg0);
		}
	};
	
    TSBPDFCertValidatorPreparedEvent.Callback onCertValidatorPrepared = new TSBPDFCertValidatorPreparedEvent.Callback() {
		
		public TElX509CertificateValidator tsbpdfCertValidatorPreparedEventCallback(
				TObject sender, TElX509CertificateValidator CertValidator,
				TElX509Certificate Cert) {
            CertValidator.addTrustedCertificates(m_TrustedCerts);
            CertValidator.addKnownCertificates(m_LocalRevInfo.getCertificates());
            CertValidator.addKnownCRLs(m_KnownCRLs);
            for (int i = 0; i < m_LocalRevInfo.getOCSPResponseCount(); i++)
            {
                TElOCSPResponse resp = new TElOCSPResponse();
                try
                {
                    byte[] encodedResp = m_LocalRevInfo.getOCSPResponse(i);
                    resp.load(encodedResp, 0, encodedResp.length);
                    CertValidator.addKnownOCSPResponses(resp);
                } catch(Exception ex) 
                {
                }
            }
            CertValidator.setForceCompleteChainValidationForTrusted(false);
			
            return CertValidator;
		}
	};
	
    private void RefreshSignaturesInfo()
    {
        signTableClear();
        for (int i = 0; i < m_CurrDoc.getSignatureCount(); i++)
        {
            SignDataRow row = RefreshSignatureInfo(m_CurrDoc.getSignatureEntry(i), false);
            signModel.addRow(row);
        }
    }
    
    private void signTableClear() {
    	signModel.clear();
	}
    
    private void RefreshRevInfo()
    {
        clearRevTable();
        revModel.addRow(m_DocRevInfo, "Document");
        revModel.addRow(m_LocalRevInfo, "Local");
    }
    
    private void clearRevTable() {
    	revModel.clear();
	}

	private void CloseCurrentDocument(boolean saveChanges)
    {
        try
        {
            if (m_CurrDoc != null)
            {
                try
                {
                    m_CurrDoc.close(saveChanges);
                }
                finally
                {
                    m_CurrDoc = null;
                }
            }
        }
        catch (Exception ex)
        {
        	ex.printStackTrace();
        }
        if (m_CurrStream != null)
        {
            DeleteTemporaryFile(saveChanges);
        }
    }
	
	protected String getOpenFileName() {
		JFileChooser fc = new JFileChooser();
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("PDF files", "pdf");
	    fc.setFileFilter(filter);	
	    
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
    private void DeleteTemporaryFile(boolean saveChanges)
    {
        if (m_CurrStream != null)
        {
            m_CurrStream.Destroy();
            m_CurrStream = null;
        }
        if (saveChanges)
        {
            try {
				copyFile(m_CurrTempFile, m_CurrOrigFile, true);
			} catch (IOException e) {
				showErrorMessage(e.getMessage());
				e.printStackTrace();
			}
        }
        new File(m_CurrTempFile).delete();
        m_CurrTempFile = "";
        m_CurrOrigFile = "";
    }


    private void PrepareTemporaryFile(String srcFile)
    {
		String TempPath = getTempFileName();
        try {
			copyFile(srcFile, TempPath, true);
		} catch (IOException e) {
			e.printStackTrace();
			showErrorMessage(e.getMessage());
		}
        m_CurrStream = new TElFileStream(TempPath, "rw", true);
        m_CurrOrigFile = srcFile;
        m_CurrTempFile = TempPath;
    }

	void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.ERROR_MESSAGE);
	}

	void showMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}

	private void copyFile(String src, String dest, boolean overwrite) throws IOException {
        RandomAccessFile inputFile = new RandomAccessFile(src, "r");
        RandomAccessFile outputFile = new RandomAccessFile(dest, "rw");
        byte[] buf = new byte[1024];
        int r;
	    
	    if (overwrite)
         outputFile.setLength(0);
	    
        do {
         r = inputFile.read(buf);
         if (r > 0)
          outputFile.write(buf, 0, r);
        } while (r > 0);

        inputFile.close();
        outputFile.close();
	}

	private String getTempFileName() {
		return System.getProperty("java.io.tmpdir") + "/" + UUID.randomUUID().toString();
	}

    private void ExtractRevInfo()
    {
        if (m_CurrDoc == null)
        {
            return;
        }
        m_DocRevInfo.clear();
        for (int i = 0; i < m_CurrDoc.getSignatureCount(); i++)
        {
            if (m_CurrDoc.getSignatureEntry(i).getHandler() instanceof TElPDFAdvancedPublicKeySecurityHandler)
            {
                TElPDFAdvancedPublicKeySecurityHandler handler = (TElPDFAdvancedPublicKeySecurityHandler)m_CurrDoc.getSignatureEntry(i).getHandler();
                handler.getCMS().extractAllCertificates(m_DocRevInfo.getCertificates());
                for (int k = 0; k < handler.getCMS().getCRLs().getCount(); k++)
                {
                    int idx = m_DocRevInfo.addCRL();
                    m_DocRevInfo.getCRL(idx).assign(handler.getCMS().getCRLs().getCRL(k));
                }
                m_DocRevInfo.assign(handler.getDSSRevocationInfo(), false);
                m_DocRevInfo.assign(handler.getRevocationInfo(), false);
            }
        }
    }
}
