import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.List;


public class SlotSelectorForm extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private final JPanel contentPanel = new JPanel();
	private final JComboBox<String> cbSlots;
	private boolean isOk;

	/**
	 * Create the dialog.
	 */
	public SlotSelectorForm() {
		setTitle("Select Slot");
		setBounds(100, 100, 325, 141);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblNewLabel = new JLabel("Available slots:");
			lblNewLabel.setBounds(10, 11, 153, 14);
			contentPanel.add(lblNewLabel);
		}
		{
			cbSlots = new JComboBox<String>();
			cbSlots.setBounds(10, 28, 283, 20);
			contentPanel.add(cbSlots);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton btnOpen = new JButton("Open");
				btnOpen.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				btnOpen.setActionCommand("OK");
				buttonPane.add(btnOpen);
				getRootPane().setDefaultButton(btnOpen);
			}
			{
				JButton btnCancel = new JButton("Cancel");
				btnCancel.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = false;
						setVisible(false);
					}
				});
				btnCancel.setActionCommand("Cancel");
				buttonPane.add(btnCancel);
			}
		}
	}
	
	public void initialize(List<String> list) {
		cbSlots.removeAllItems();
		
		for (String s : list)
			cbSlots.addItem(s);
	}

	public boolean isOK() {
		return isOk;
	}
	
	public int getSlotIndex() {
		return cbSlots.getSelectedIndex();
	}
}
