

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.SwingConstants;
import javax.swing.JTextField;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JPasswordField;
import javax.swing.JButton;
import javax.swing.border.TitledBorder;
import javax.swing.table.TableColumn;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.SSHClient.*;
import SecureBlackbox.SSHCommon.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Date;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTextField tbHost;
	private JTextField tbUsername;
	private JPasswordField tbPassword;
	private JTextField tbDestHost;
	private JTable table;
	private JTable tableLog;
	private JSpinner tbPort;
	private JSpinner tbDestPort;
	private JButton btnStart;
	private TElSSHLocalPortForwarding forwarding;
	private JSpinner tbForwardedPort;


	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setResizable(false);
		setTitle("SSH local port forwarding demo application");
		setBounds(100, 100, 761, 514);
		getContentPane().setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(0, 0, 234, 487);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblSshSettings = new JLabel("SSH Settings");
		lblSshSettings.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		lblSshSettings.setHorizontalAlignment(SwingConstants.CENTER);
		lblSshSettings.setBackground(Color.GRAY);
		lblSshSettings.setBounds(10, 11, 192, 14);
		panel.add(lblSshSettings);
		
		JLabel lblServerSettings = new JLabel("Server address:");
		lblServerSettings.setBounds(10, 36, 129, 14);
		panel.add(lblServerSettings);
		
		tbHost = new JTextField();
		tbHost.setText("192.168.0.1");
		tbHost.setBounds(10, 51, 115, 20);
		panel.add(tbHost);
		tbHost.setColumns(10);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(149, 36, 46, 14);
		panel.add(lblPort);
		
		tbPort = new JSpinner();
		tbPort.setModel(new SpinnerNumberModel(new Integer(22), null, null, new Integer(1)));
		tbPort.setBounds(149, 51, 53, 20);
		panel.add(tbPort);
		
		JLabel lblUsername = new JLabel("Username:");
		lblUsername.setBounds(10, 82, 102, 14);
		panel.add(lblUsername);
		
		tbUsername = new JTextField();
		tbUsername.setText("user");
		tbUsername.setBounds(10, 98, 115, 20);
		panel.add(tbUsername);
		tbUsername.setColumns(10);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(10, 129, 78, 14);
		panel.add(lblPassword);
		
		tbPassword = new JPasswordField();
		tbPassword.setBounds(10, 146, 115, 20);
		panel.add(tbPassword);
		tbPassword.setColumns(10);
		
		JLabel lblForwardSettings = new JLabel("Forward Settings");
		lblForwardSettings.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		lblForwardSettings.setHorizontalAlignment(SwingConstants.CENTER);
		lblForwardSettings.setBounds(10, 191, 192, 14);
		panel.add(lblForwardSettings);
		
		JLabel lblLocalPort = new JLabel("Forwarded Port");
		lblLocalPort.setBounds(10, 216, 129, 14);
		panel.add(lblLocalPort);
		
		tbForwardedPort = new JSpinner();
		tbForwardedPort.setModel(new SpinnerNumberModel(new Integer(5001), null, null, new Integer(1)));
		tbForwardedPort.setBounds(10, 236, 63, 20);
		panel.add(tbForwardedPort);
		
		JLabel lblRemoteHostAnd = new JLabel("Destination host and port");
		lblRemoteHostAnd.setBounds(10, 267, 214, 14);
		panel.add(lblRemoteHostAnd);
		
		tbDestHost = new JTextField();
		tbDestHost.setText("127.0.0.1");
		tbDestHost.setColumns(10);
		tbDestHost.setBounds(10, 283, 115, 20);
		panel.add(tbDestHost);
		
		tbDestPort = new JSpinner();
		tbDestPort.setModel(new SpinnerNumberModel(new Integer(5001), null, null, new Integer(1)));
		tbDestPort.setBounds(149, 283, 53, 20);
		panel.add(tbDestPort);
		
		btnStart = new JButton("Start");
		btnStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				startClick();
			}
		});
		btnStart.setBounds(63, 327, 89, 23);
		panel.add(btnStart);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBounds(234, 0, 519, 487);
		getContentPane().add(panel_1);
		panel_1.setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		scrollPane.setBounds(0, 401, 519, 86);
		panel_1.add(scrollPane);
		
		tableLog = new JTable(new LogTableModel());
		tableLog.setFillsViewportHeight(true);
		scrollPane.setViewportView(tableLog);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		scrollPane_1.setBounds(0, 0, 519, 400);
		panel_1.add(scrollPane_1);
		
		table = new JTable(new ConTableModel());
		TableColumn col = table.getColumnModel().getColumn(ConTableModel.ICON_INDEX);
		col.setCellRenderer(new ConTableCellRenderer());
		table.setFillsViewportHeight(true);
		scrollPane_1.setViewportView(table);
		
		init();
	}

	private void init() {
        #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
        SBUtils.setLicenseKey("<put the key here>");

        
        forwarding = new TElSSHLocalPortForwarding();
            
        TElDNSSettings tElDNSSettings1 = new TElDNSSettings();
        
        forwarding.setAuthAttempts(1);
        forwarding.setAuthenticationTypes(4);
        forwarding.setAutoAdjustPriority(true);
        forwarding.setCertAuthMode(TSBSSHCertAuthMode.camAuto);
        forwarding.setCloseIfNoActiveTunnels(true);
        forwarding.setDefaultWindowSize(2048000);
        tElDNSSettings1.setAllowStatuses(((byte)(11)));
        tElDNSSettings1.setPort((short) 53);
        tElDNSSettings1.setQueryTimeout((short)3000);
        tElDNSSettings1.setTotalTimeout((short)15000);
        forwarding.setDNS(tElDNSSettings1);
        forwarding.setFlushCachedDataOnClose(true);
        forwarding.setForceCompression(false);
        forwarding.setForwardedHost("");
        forwarding.setForwardedPort(0);
        forwarding.setForwardedUseIPv6(false);
        forwarding.setGlobalKeepAlivePeriod(0);
        forwarding.setIncomingSpeedLimit(0);
        forwarding.setKeepAlivePeriod(0);
        forwarding.setMaxSSHPacketSize(262144);
        forwarding.setMinWindowSize(2048);
        forwarding.setSoftwareName("SSHBlackbox.8");
        forwarding.setSSHAuthOrder(TSBSSHAuthOrder.aoDefault);
        forwarding.setSynchronizeGUI(true);
        forwarding.setTrustedKeys(null);
        forwarding.setUseDynamicForwarding(false);
        forwarding.setUseIPv6(false);
        forwarding.setUsername(null);
        forwarding.setUseUTF8(false);
        forwarding.setVersions(((short)(2)));
        forwarding.setOnAuthenticationFailed(new TSSHAuthenticationFailedEvent(forwarding_OnAuthenticationFailed));
        forwarding.setOnAuthenticationSuccess(new TNotifyEvent(forwarding_OnAuthenticationSuccess));
        forwarding.setOnError(new TSSHErrorEvent(forwarding_OnError));
        forwarding.setOnKeyValidate(new TSSHKeyValidateEvent(forwarding_OnKeyValidate));
        forwarding.setOnOpen(new TNotifyEvent(forwarding_OnOpen));
        forwarding.setOnClose(new TNotifyEvent(forwarding_OnClose));
        forwarding.setOnConnectionOpen(new TSBSSHConnectionEvent(forwarding_OnConnectionOpen));
        forwarding.setOnConnectionClose(new TSBSSHConnectionEvent(forwarding_OnConnectionClose));
        forwarding.setOnConnectionChange(new TSBSSHConnectionEvent(forwarding_OnConnectionChange));
        forwarding.setOnConnectionError(new TSBSSHConnectionErrorEvent(forwarding_OnConnectionError));
	}
	
	TSSHAuthenticationFailedEvent.Callback forwarding_OnAuthenticationFailed = new TSSHAuthenticationFailedEvent.Callback() {
		
		
		public void tsshAuthenticationFailedEventCallback(TObject sender, int AuthenticationType) {
			Log("Authentication [" + AuthenticationType + "] failed", true);
		}
	};
	
	TNotifyEvent.Callback forwarding_OnAuthenticationSuccess = new TNotifyEvent.Callback() {
		
		
		public void tNotifyEventCallback(TObject sender) {
			Log("Authentication succeeded", false);
		}
	};
	
	TSSHErrorEvent.Callback forwarding_OnError = new TSSHErrorEvent.Callback() {
		
		
		public void tsshErrorEventCallback(TObject sender, int errorCode) {
			Log("SSH error [" + errorCode + "]", true);
			Log("If you have ensured that all connection parameters are correct and you still can't connect,", true);
			Log("please contact EldoS support as described on http://www.eldos.com/sbb/support-tech.php", true);
			Log("Remember to provide details about the error that happened.", true);
			if (forwarding.getServerSoftwareName().length() > 0)
				Log("Server software identified itself as: " + forwarding.getServerSoftwareName(), true);			
		}
	};
	
	TSSHKeyValidateEvent.Callback forwarding_OnKeyValidate = new TSSHKeyValidateEvent.Callback() {
		
		
		public void tsshKeyValidateEventCallback(TObject sender, TElSSHKey ServerKey, TSBBoolean accept) {
			String s = SBUtils.digestToStr128(ServerKey.getFingerprintMD5(), true);
			Log("Server key received [" + s + "]", false);
			accept.value = true;
		}
	};
	
	TNotifyEvent.Callback forwarding_OnOpen = new TNotifyEvent.Callback() {
		
		
		public void tNotifyEventCallback(TObject sender) {
			Log("SSH session opened", false);
		}
	};
	
	TNotifyEvent.Callback forwarding_OnClose = new TNotifyEvent.Callback() {
		
		
		public void tNotifyEventCallback(TObject sender) {
			Log("SSH session closed", false);
            btnStart.setText("Start");
		}
	};
	
	TSBSSHConnectionEvent.Callback forwarding_OnConnectionOpen = new TSBSSHConnectionEvent.Callback() {
		
		
		public void tsbsshConnectionEventCallback(TObject sender,
				TElSSHForwardedConnection conn) {
			Log("Secure channel opened", false);
			AddConnection(conn);
		}
	};

	TSBSSHConnectionEvent.Callback forwarding_OnConnectionClose = new TSBSSHConnectionEvent.Callback() {
		
		
		public void tsbsshConnectionEventCallback(TObject sender,
				TElSSHForwardedConnection conn) {
			Log("Secure channel closed", false);
			RemoveConnection(conn.getData());			
		}
	};
	
	TSBSSHConnectionEvent.Callback forwarding_OnConnectionChange = new TSBSSHConnectionEvent.Callback() {
		
		
		public void tsbsshConnectionEventCallback(TObject sender,
				TElSSHForwardedConnection conn) {
			RefreshConnection(conn);
		}
	};
	
	TSBSSHConnectionErrorEvent.Callback forwarding_OnConnectionError = new TSBSSHConnectionErrorEvent.Callback() {
		
		
		public void tsbsshConnectionErrorEventCallback(TObject sender,
				TElSSHForwardedConnection conn, int ErrorCode) {
			Log("Secure channel error [" + ErrorCode + "]", true);
			Log("If you have ensured that all connection parameters are correct and you still can't connect,", true);
			Log("please contact EldoS support as described on http://www.eldos.com/sbb/support-tech.php", true);
			Log("Remember to provide details about the error that happened.", true);			
		}
	};
	
	protected void startClick() {
		if (!forwarding.getActive()) 
		{
			forwarding.setAddress(tbHost.getText());
			forwarding.setPort((Integer)tbPort.getValue());
			forwarding.setForwardedHost("");
			forwarding.setForwardedPort((Integer)tbForwardedPort.getValue());
			forwarding.setDestHost(tbDestHost.getText());
			forwarding.setDestPort((Integer)tbDestPort.getValue());
			forwarding.setUsername(tbUsername.getText());
			forwarding.setPassword(new String(tbPassword.getPassword()));
			forwarding.open();
			btnStart.setText("Stop");
		} 
		else 
		{
			forwarding.close();
		}
	}


	protected void RemoveConnection(TObject data) {
		ConTableModel model = (ConTableModel)table.getModel();
		model.remove((TElSSHForwardedConnection) data);
	}

	protected void AddConnection(TElSSHForwardedConnection conn) {
		ConTableModel model = (ConTableModel)table.getModel();
		model.addRow(conn);
	}

	protected void RefreshConnection(TElSSHForwardedConnection conn) {
		ConTableModel model = (ConTableModel)table.getModel();
		model.change(conn);
	}

	protected void Log(String s, boolean b) {
		LogTableModel model = (LogTableModel)tableLog.getModel();
		model.addRow(new Date(), s, b ? "E" : "I");
	}
}
