import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JCheckBox;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class ConPropsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbHost;
	private JTextField tbUser;
	private JPasswordField tbPassword;
	private JTextField tbPrivateKey;
	private JPasswordField tbKeyPassword;
	private boolean isOk;
	private JCheckBox chckbxSSHv;
	private JCheckBox chckbxSshv2;
	private JCheckBox chckbxCompress;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ConPropsDialog dialog = new ConPropsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ConPropsDialog() {
		setTitle("Connection properties");
		setBounds(100, 100, 416, 365);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBorder(new TitledBorder(null, "Connection properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			panel.setBounds(10, 11, 388, 271);
			contentPanel.add(panel);
			panel.setLayout(null);
			
			JLabel lblHost = new JLabel("Host");
			lblHost.setBounds(10, 20, 46, 14);
			panel.add(lblHost);
			
			tbHost = new JTextField();
			tbHost.setText("192.168.0.1");
			tbHost.setBounds(10, 37, 161, 20);
			panel.add(tbHost);
			tbHost.setColumns(10);
			
			JLabel lblUsername = new JLabel("Username");
			lblUsername.setBounds(10, 68, 106, 14);
			panel.add(lblUsername);
			
			tbUser = new JTextField();
			tbUser.setText("user");
			tbUser.setBounds(10, 84, 161, 20);
			panel.add(tbUser);
			tbUser.setColumns(10);
			
			JLabel lblPassword = new JLabel("Password");
			lblPassword.setBounds(10, 115, 119, 14);
			panel.add(lblPassword);
			
			tbPassword = new JPasswordField();
			tbPassword.setBounds(10, 131, 161, 20);
			panel.add(tbPassword);
			
			JLabel lblPrivateKeyFile = new JLabel("Private key file for PUBLICKEY authentication type");
			lblPrivateKeyFile.setBounds(10, 162, 351, 14);
			panel.add(lblPrivateKeyFile);
			
			tbPrivateKey = new JTextField();
			tbPrivateKey.setBounds(10, 180, 312, 20);
			panel.add(tbPrivateKey);
			tbPrivateKey.setColumns(10);
			
			JButton btnBrowse = new JButton("..");
			btnBrowse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					tbPrivateKey.setText(getFileName());
				}
			});
			btnBrowse.setBounds(332, 179, 46, 23);
			panel.add(btnBrowse);
			
			JLabel lblPasswordForA = new JLabel("Password for a key file:");
			lblPasswordForA.setBounds(10, 211, 241, 14);
			panel.add(lblPasswordForA);
			
			tbKeyPassword = new JPasswordField();
			tbKeyPassword.setBounds(10, 225, 149, 20);
			panel.add(tbKeyPassword);
			
			chckbxSSHv = new JCheckBox("SSHv");
			chckbxSSHv.setSelected(true);
			chckbxSSHv.setBounds(196, 59, 97, 23);
			panel.add(chckbxSSHv);
			
			chckbxSshv2 = new JCheckBox("SSHv2");
			chckbxSshv2.setSelected(true);
			chckbxSshv2.setBounds(196, 83, 97, 23);
			panel.add(chckbxSshv2);
			
			chckbxCompress = new JCheckBox("Compress");
			chckbxCompress.setBounds(196, 106, 97, 23);
			panel.add(chckbxCompress);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	String getFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	public boolean isOK() {
		return isOk;
	}

	public String getHost() {
		return tbHost.getText();
	}

	public String getUser() {
		return tbUser.getText();
	}

	public String getPassword() {
		return new String(tbPassword.getPassword());
	}

	public boolean getSSH1() {
		return chckbxSSHv.isSelected();
	}

	public boolean getSSH2() {
		return chckbxSshv2.isSelected();
	}

	public boolean getCompress() {
		return chckbxCompress.isSelected();
	}

	public String getPrivateKey() {
		return tbPrivateKey.getText();
	}

	public String getKeyPassword() {
		return new String(tbKeyPassword.getPassword());
	}
}
