import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JSeparator;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.Base.SBStrUtils;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.SBX509;
import SecureBlackbox.Base.TByteArrayConst;
import SecureBlackbox.Base.TElCustomCertStorage;
import SecureBlackbox.Base.TElMemoryCertStorage;
import SecureBlackbox.Base.TElRelativeDistinguishedName;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.Base.TSBInteger;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import javax.swing.JList;
import javax.swing.border.LineBorder;
import java.awt.Color;

public class SelectCertDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final static String sDefCertPswdInCustStorage = "{37907B5C-B309-4AE4-AFD2-2EAE948EADA2}";

	private final JPanel contentPanel = new JPanel();
	private TElMemoryCertStorage FCertStorage;
	private JList<String> list;
	private boolean isOk;
	private DefaultListModel<String> listModel;
	private TSelectCertMode FMode;
	private JLabel lblPleaseChooseCertificates;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			SelectCertDialog dialog = new SelectCertDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public SelectCertDialog() {
		setTitle("Select certificates");
		setBounds(100, 100, 568, 287);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		lblPleaseChooseCertificates = new JLabel("Please, choose certificates.");
		lblPleaseChooseCertificates.setBounds(10, 11, 239, 14);
		contentPanel.add(lblPleaseChooseCertificates);
		
		JButton btnAddCertificate = new JButton("Add certificate");
		btnAddCertificate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					addCert();
				} catch (Exception ex) {
					showErrorMessage(ex);
				}
			}
		});
		btnAddCertificate.setBounds(404, 35, 146, 23);
		contentPanel.add(btnAddCertificate);
		
		JButton btnRemoveCertificate = new JButton("Remove certificate");
		btnRemoveCertificate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeCert();
			}
		});
		btnRemoveCertificate.setBounds(404, 69, 146, 23);
		contentPanel.add(btnRemoveCertificate);
		
		JButton btnLoadStorage = new JButton("Load Storage");
		btnLoadStorage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				loadStorage();
			}
		});
		btnLoadStorage.setBounds(404, 116, 146, 23);
		contentPanel.add(btnLoadStorage);
		
		JButton btnSaveStorage = new JButton("Save Storage");
		btnSaveStorage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveStorage();
			}
		});
		btnSaveStorage.setBounds(404, 150, 146, 23);
		contentPanel.add(btnSaveStorage);
		
		JSeparator separator = new JSeparator();
		separator.setBounds(404, 103, 146, 2);
		contentPanel.add(separator);
		
		JSeparator separator_1 = new JSeparator();
		separator_1.setBounds(10, 220, 540, 2);
		contentPanel.add(separator_1);
		
		listModel = new DefaultListModel<String>();
		list = new JList<String>(listModel);
		list.setBorder(new LineBorder(new Color(0, 0, 0)));
		list.setBounds(10, 36, 386, 149);
		contentPanel.add(list);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = false;
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		FCertStorage = new TElMemoryCertStorage();
	}

	String getSaveFileName(String title, String filtr, String extension){
		JFileChooser fc = new JFileChooser();

		fc.setDialogTitle(title);

		FileNameExtensionFilter filter = new FileNameExtensionFilter(filtr, extension);
		fc.setFileFilter(filter);
		
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected void saveStorage() {
		String fileName = getSaveFileName("Save Storage", 
				"Users Certificates Storage", "ucs");
		if (fileName.length() > 0)
			try {
				saveStorage(fileName, FCertStorage);
			} catch (Exception e) {
				showErrorMessage(e);
			}			
	}

	String getLoadFileName(String title, String filtr, String extension){
		JFileChooser fc = new JFileChooser();

		fc.setDialogTitle(title);

		FileNameExtensionFilter filter = new FileNameExtensionFilter(filtr, extension);
		fc.setFileFilter(filter);
		
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	protected void loadStorage() {
		
		String fileName = getLoadFileName("Load Storage", 
				"Users Certificates Storage", "ucs");
		if (fileName.length() > 0)
			try {
				loadStorage(fileName, FCertStorage);
			} catch (Exception e) {
				showErrorMessage(e);
			}
		
		updateCertificatesList();
	}

	public void loadStorage(String sFileName, TElCustomCertStorage CertStorage) throws Exception
	{
		CertStorage.clear();
		if (!new File(sFileName).exists())
			return;

		FileInputStream fs = new FileInputStream(sFileName);
		try
		{
			CheckSBB(
				CertStorage.loadFromStreamPFX(fs, sDefCertPswdInCustStorage, 0),
				"Cannot load certificates from file storage: '" + sFileName + "'"
				);
		} finally {
			fs.close();	
		}
	}

	public static void CheckSBB(int iErrorCode, String sErrorMessage) throws Exception
	{
		if (iErrorCode != 0)
			throw new Exception(sErrorMessage + ". Error code: '" + iErrorCode + "'.");
	}

	public static void saveStorage(String sFileName, TElCustomCertStorage CertStorage) throws Exception
	{
		FileOutputStream fs = new FileOutputStream(sFileName);
		try
		{
			int iError = CertStorage.saveToStreamPFX(fs, sDefCertPswdInCustStorage,
				SBConstants.SB_ALGORITHM_PBE_SHA1_3DES, 
				SBConstants.SB_ALGORITHM_PBE_SHA1_3DES);

			if (iError != 0)
				CheckSBB(iError, "SaveToStreamPFX failed to save the storage");
		}
		finally
		{
			fs.close();
		}
	}

	
	protected void removeCert() {
		listModel.remove(list.getSelectedIndex());		
	}

	String getFileName(){
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select certificate file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( PEM | DER | PFX )-encoded certificate", "pem", "cer", "pfx");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	private String getPrivateKey() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select the corresponding private key file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( PEM | DER )-encoded certificate", "pem", "key");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	private int getPrivateKeyFilterIndex(String privKey) {
		if (extension(privKey).toLowerCase().compareTo("pem") == 0) return 1;
		return 0;
	}
	
	public String extension(String fullPath) {
	    int dot = fullPath.lastIndexOf('.');
	    return fullPath.substring(dot + 1);
	}
	
	protected void addCert() throws Exception {
		boolean KeyLoaded = false;
		String fileName = getFileName();
		if (fileName.length() == 0)
			return;

		int Res = 0;
		TElX509Certificate Cert = new TElX509Certificate(null);
    	
    	int length = (int) new File(fileName).length();
    	FileInputStream F = new FileInputStream(fileName);

		byte [] Buf = new byte[length];
		F.read(Buf, 0, length);

    	int CertFormat = TElX509Certificate.detectCertFileFormat(fileName);
   	
        if (CertFormat == SBX509.cfDER)
        {
			Cert.loadFromBuffer(Buf);
		}
        else if (CertFormat == SBX509.cfPEM)
        {
			Res = Cert.loadFromBufferPEM(Buf, "");
		}
        else if (CertFormat == SBX509.cfPFX)
        {
			Res = Cert.loadFromBufferPFX(Buf, requestPassphrase());
        }
        else
			Res = -1;
        
        F.close();
    	
		if ((Res != 0) || (Cert.getCertificateSize() == 0))
		{				
			showErrorMessage("SSL Sample", "Error loading the certificate");
			return;
		}

		TSBInteger Sz = new TSBInteger();
		Buf = null;
		Cert.saveKeyToBuffer(Buf, Sz);

		if (Sz.value == 0)
		{
			String privKey = getPrivateKey();
			if (privKey.length() > 0)
			{
				length = (int) new File(privKey).length();
				F = new FileInputStream(privKey);
				Buf = new byte[length];
				F.read(Buf, 0, (int)length);
				F.close();

				if (getPrivateKeyFilterIndex(privKey) == 1)
					Cert.loadKeyFromBufferPEM(Buf, requestPassphrase());
				else
					Cert.loadKeyFromBuffer(Buf);

				KeyLoaded = true;
			}
		}
		else
			KeyLoaded = true;

		if (!KeyLoaded)
			showMessage("SSL Sample", "Private key was not loaded. Certificate added without private key.");

		if (!FCertStorage.isPresent(Cert))
			FCertStorage.add(Cert, true);

		updateCertificatesList();		
	}

	private void updateCertificatesList() {
		String s, t;
		for (int i = 0; i < FCertStorage.getCount(); i++)
		{
			s = getOIDValue(FCertStorage.getCertificate(i).getSubjectRDN(), SBConstants.SB_CERT_OID_COMMON_NAME);
			if (s == "")
				s = getOIDValue(FCertStorage.getCertificate(i).getSubjectRDN(), SBConstants.SB_CERT_OID_ORGANIZATION);

			if (s == "")
				s = "<unknown>";

			t = getOIDValue(FCertStorage.getCertificate(i).getIssuerRDN(), SBConstants.SB_CERT_OID_COMMON_NAME);
			if (t == "")
				t = getOIDValue(FCertStorage.getCertificate(i).getIssuerRDN(), SBConstants.SB_CERT_OID_ORGANIZATION);

			if (t == "")
				t = "<unknown>";

			addCertificatesItem(s + " (" + t + ")");
		}		
	}
	
	private void addCertificatesItem(String s) {
		listModel.addElement(s);
	}

	public String getOIDValue(TElRelativeDistinguishedName RDN, TByteArrayConst sb)
	{
		String t = "";
		int iCount = RDN.getCount();
		for (int i = 0; i < iCount; i++)
		{
			if (SBUtils.compareContent(RDN.getOID(i), sb.Data))
			{
				if (t != "")
					t += " / ";

				t += SBStrUtils.utf8ToStr(RDN.getValue(i));
			}
		}

		return t;
	}
	
	protected void showErrorMessage(Exception e) {
		JOptionPane.showMessageDialog(null, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
	}

	static void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}

	private void showMessage(String cap, String msg) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.INFORMATION_MESSAGE);	
	}
	
	private void showErrorMessage(String cap, String msg) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);
	}

	private String requestPassphrase() {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Please enter password", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}

	public TElMemoryCertStorage getStorage(TElMemoryCertStorage value) {
		if (value == null)
			value = new TElMemoryCertStorage();
		else
			value.clear();

		FCertStorage.exportTo(value);
		
		return value;
	}

	public boolean isOk() {
		return isOk;
	}

	public void setStorage(TElMemoryCertStorage value) {
		FCertStorage.clear();
		if (value != null)
			value.exportTo(FCertStorage);

		updateCertificatesList();
	}
	
	public void setMode(TSelectCertMode Value) {
		FMode = Value;
		if (FMode == TSelectCertMode.ClientCert)
			lblPleaseChooseCertificates.setText("Please, choose client-side certificate or certificate chain.\r\nThe server has client authentication enabled.");
		else if (FMode == TSelectCertMode.ServerCert)
			lblPleaseChooseCertificates.setText("Please, choose server certificates.");
		else
			lblPleaseChooseCertificates.setText("Please, choose certificates.");
	}
}
