import SecureBlackbox.Base.SBSocket;
import SecureBlackbox.Base.TElSocket;
import SecureBlackbox.Base.TSBInteger;


public class TcpClient {
	TElSocket m_socket;
	public TcpClient(TElSocket socket) {
		m_socket = socket;
	}
	
	public void close() {
		m_socket.close(false, 5000);
	}

	public boolean GetDataAvailable() {
		if (m_socket.getState() != SBSocket.issConnected)
			return false;
		
		return m_socket.canReceive(10000);
	}

	public int read(byte[] buffer, int offset, int size) {
		TSBInteger result = new TSBInteger();
		m_socket.receive(buffer, size, result);
		return result.value;
	}

	public void write(byte[] buffer, int offset, int size) {
		try 
		{
			int toSend = buffer.length;
			TSBInteger sent = new TSBInteger();
			sent.value = 0;
			int ptr = 0;
			while (toSend > 0) 
			{
				m_socket.send(buffer, ptr, toSend, sent);
				ptr += sent.value;
				toSend -= sent.value;
			}
		} 
		catch(Exception ex)
		{
            Logger.Log("Socket send operation failed: " + ex.getMessage());
			//close();
		}
	}
}