import java.awt.EventQueue;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTable;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.XML.*;
import SecureBlackbox.XMLSecurity.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Date;
import java.util.Arrays;
import javax.swing.ListSelectionModel;


public class MainFrm {

	private JFrame frmSecureSoap;
	private JTextField textXMLFile;
	private JComboBox<String> cbCharset;
	private JButton btnLoadSOAP, btnSaveSOAP, btnAddSignature, btnRemoveSignature, btnVerifySignature;
	private JCheckBox cbNormalizeNEL;
	
	private TElXMLDOMDocument doc;
	private TElXMLSOAPMessage soap;
	private JTable tableSignatures;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainFrm window = new MainFrm();
					window.frmSecureSoap.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public MainFrm() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		SBXMLSOAP.initialize();
		SBXMLSOAPSecurity.initialize();
		
		JNI.initialize(); // JNI module
		
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmSecureSoap = new JFrame();
		frmSecureSoap.setTitle("Secure SOAP");
		frmSecureSoap.setBounds(100, 100, 809, 301);
		frmSecureSoap.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmSecureSoap.getContentPane().setLayout(null);
		
		JLabel lblNewLabel = new JLabel("SOAP File:");
		lblNewLabel.setBounds(10, 11, 60, 14);
		frmSecureSoap.getContentPane().add(lblNewLabel);
		
		textXMLFile = new JTextField();
		textXMLFile.setBounds(80, 8, 507, 20);
		frmSecureSoap.getContentPane().add(textXMLFile);
		textXMLFile.setColumns(10);
		
		JButton btnBrowseFile = new JButton("...");
		btnBrowseFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doChooseFile();
			}
		});
		btnBrowseFile.setBounds(597, 7, 35, 23);
		frmSecureSoap.getContentPane().add(btnBrowseFile);
		
		btnLoadSOAP = new JButton("Load SOAP");
		btnLoadSOAP.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doLoadSOAP();
			}
		});
		btnLoadSOAP.setBounds(642, 7, 136, 23);
		frmSecureSoap.getContentPane().add(btnLoadSOAP);
		
		btnSaveSOAP = new JButton("Save SOAP");
		btnSaveSOAP.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doSaveSOAP();
			}
		});
		btnSaveSOAP.setBounds(642, 37, 136, 23);
		frmSecureSoap.getContentPane().add(btnSaveSOAP);
		
		cbNormalizeNEL = new JCheckBox("Normalize newline characters on load");
		cbNormalizeNEL.setSelected(true);
		cbNormalizeNEL.setBounds(10, 37, 264, 23);
		frmSecureSoap.getContentPane().add(cbNormalizeNEL);
		
		JLabel lblNewLabel_1 = new JLabel("Charset:");
		lblNewLabel_1.setBounds(347, 41, 60, 14);
		frmSecureSoap.getContentPane().add(lblNewLabel_1);
		
		cbCharset = new JComboBox<String>();
		cbCharset.setBounds(407, 39, 225, 20);
		frmSecureSoap.getContentPane().add(cbCharset);
		
		JLabel lblNewLabel_2 = new JLabel("Signatures:");
		lblNewLabel_2.setBounds(10, 82, 136, 14);
		frmSecureSoap.getContentPane().add(lblNewLabel_2);
		
		btnAddSignature = new JButton("Add Signature...");
		btnAddSignature.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doAddSignature();
			}
		});
		btnAddSignature.setBounds(10, 222, 150, 23);
		frmSecureSoap.getContentPane().add(btnAddSignature);
		
		btnRemoveSignature = new JButton("Remove Signature...");
		btnRemoveSignature.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doRemoveSignature();
			}
		});
		btnRemoveSignature.setBounds(170, 222, 150, 23);
		frmSecureSoap.getContentPane().add(btnRemoveSignature);
		
		btnVerifySignature = new JButton("Verify Signature...");
		btnVerifySignature.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doVerifySignature();
			}
		});
		btnVerifySignature.setBounds(330, 222, 150, 23);
		frmSecureSoap.getContentPane().add(btnVerifySignature);
		
		JButton btnClose = new JButton("Close");
		btnClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doClose();
			}
		});
		btnClose.setBounds(689, 222, 89, 23);
		frmSecureSoap.getContentPane().add(btnClose);
		
		// init
		
		cbCharset.addItem("");
		SBChSConv.enumCharsets(new TEnumCharsetsProc(new TEnumCharsetsProc.Callback() {
			public boolean tEnumCharsetsProcCallback(String category, String description, String name, String aliases, Object userData) {
				@SuppressWarnings("unchecked")
				JComboBox<String> cb = (JComboBox<String>)userData;
				cb.addItem(name);
				return false;
			}
		}), cbCharset);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 107, 768, 104);
		frmSecureSoap.getContentPane().add(scrollPane);
		
		tableSignatures = new JTable(new SignaturesTableModel());
		tableSignatures.setFillsViewportHeight(true);
		tableSignatures.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		scrollPane.setViewportView(tableSignatures);
		
		updateInfo();
	}
	
	private void doVerifySignature() {
		if (tableSignatures.getSelectedRow() < 0)
			return;
		
		TElXMLSOAPCustomSignatureHandler handler = soap.getSignatureHandler(tableSignatures.getSelectedRow());
		if (handler instanceof TElXMLSOAPBaseSignatureHandler)
			validateSignature((TElXMLSOAPBaseSignatureHandler)handler);
		else
			JOptionPane.showMessageDialog(null, "Unsupported signature handler", "Info", JOptionPane.INFORMATION_MESSAGE);
	}

	private boolean validateSignature(TElXMLSOAPBaseSignatureHandler handler) {
		TSBCertificateValidity validity = TSBCertificateValidity.cvInvalid;
		int certReason = 0;
		boolean result = true;
		Date validationMoment = SBUtils.utcNow();

		TSBXMLSOAPSignatureValidationStatus status = handler.validate();
		
		if (status == TSBXMLSOAPSignatureValidationStatus.ssvsNoKey) {
			SelectKeyFrm frmSelectKey = new SelectKeyFrm();
			frmSelectKey.init(handler.getVerifier());
			frmSelectKey.setModal(true);
			frmSelectKey.setVisible(true);
			
			if ( ! frmSelectKey.isOK()) {
				SignatureHandlerInfoFrm frmSignatureHandlerInfo = new SignatureHandlerInfoFrm();
				frmSignatureHandlerInfo.init(handler, status, validity, certReason);
				frmSignatureHandlerInfo.setModal(true);
				frmSignatureHandlerInfo.setVisible(true);
				return false;
			}
			
			TElX509Certificate cert = handler.getSignerCertificate();
			if (cert != null)
				status = handler.validate(cert);
			else
				status = handler.validate(frmSelectKey.getKeyData());
		}
		
		if ((status != TSBXMLSOAPSignatureValidationStatus.ssvsValid) && (status != TSBXMLSOAPSignatureValidationStatus.ssvsInvalidReferenceDigest)) {
			SignatureHandlerInfoFrm frmSignatureHandlerInfo = new SignatureHandlerInfoFrm();
			frmSignatureHandlerInfo.init(handler, status, validity, certReason);
			frmSignatureHandlerInfo.setModal(true);
			frmSignatureHandlerInfo.setVisible(true);
			return false;
		}
		
		// signature is valid (SignedInfo element integrity is ok)
		// validate a certificate used for signature validation
		if (handler.getSignerCertificate() != null) {
			TElX509CertificateValidator validator = new TElX509CertificateValidator();
			TElX509CertificateValidatorResult res = new TElX509CertificateValidatorResult();
			validator.validate(handler.getSignerCertificate(), null, true, SBUtils.now(), res);
			validity = res.Validity;
			certReason = res.Reason;
			
			if ((validity != TSBCertificateValidity.cvSelfSigned) && (validity != TSBCertificateValidity.cvOk))
				result = false;
		}
		
		SignatureHandlerInfoFrm frmSignatureHandlerInfo = new SignatureHandlerInfoFrm();
		frmSignatureHandlerInfo.init(handler, status, validity, certReason);
		frmSignatureHandlerInfo.setModal(true);
		frmSignatureHandlerInfo.setVisible(true);
		
		if (status == TSBXMLSOAPSignatureValidationStatus.ssvsInvalidReferenceDigest) {
			status = handler.validate();
		}
		
		if (handler.getXAdESProcessor() instanceof TElXAdESVerifier) {
			TElXAdESVerifier verifier = (TElXAdESVerifier)handler.getXAdESProcessor();
			if (verifier.getIsEnabled()) {
				TElXAdESVerifierResult xadesRes = verifier.validate();
				if (xadesRes.Validity == TSBXAdESValidity.xsvValid)
					result = false;
				
				XADESInfoFrm frmXAdESInfo = new XADESInfoFrm();
				frmXAdESInfo.init(verifier, xadesRes.Validity, xadesRes.Reasons, validationMoment);
				frmXAdESInfo.setModal(true);
				frmXAdESInfo.setVisible(true);
			}
		}
		
		return result && (status == TSBXMLSOAPSignatureValidationStatus.ssvsValid);
	}

	private void doSaveSOAP() {
		TElFileStream fs = new TElFileStream(textXMLFile.getText(), "rw", false);
		try {
			try {
				doc.saveToStream(fs, SBXMLDefs.xcmNone, (String)cbCharset.getSelectedItem());
			} catch (Exception ex) {
				ex.printStackTrace();
				showMessage("Failed to save XML document: " + ex.getMessage());
			}
		} finally {
			fs.close();
		}
	}
	
	private void doLoadSOAP() {
		String path = textXMLFile.getText();
		boolean loaded = false;
		
		if ("".equals(path)) {
			doChooseFile();
			path = textXMLFile.getText();
			if ("".equals(path))
				return;
		}
		
		doc = new TElXMLDOMDocument();
		soap = new TElXMLSOAPMessage();
		
		TElFileStream fs = new TElFileStream(textXMLFile.getText(), "r", false);
		try {
			try {
				doc.loadFromStream(fs, (String)cbCharset.getSelectedItem(), cbNormalizeNEL.isSelected());
				loaded = true;
			} catch (Exception ex) {
				ex.printStackTrace();
				showMessage("Failed to load XML document: " + ex.getMessage());
			}
		} finally {
			fs.close();
		}
		
		if (loaded) {
			if (doc.getDocumentType() != null) {
				if (doc.getDocumentType().getSystemID().length() > 0) {
					byte[] buf = Utils.downloadData(doc.getDocumentType().getSystemID());
					doc.getDocumentType().resolveExternalDTD(SBStrUtils.utf8ToStr(buf));
				}
			}
			
			try {
				soap.loadFromXML(doc);
			} catch (Exception ex) {
				ex.printStackTrace();
				showMessage("Failed to load SOAP message: " + ex.getMessage());
			}
		} else
			soap.clear();
		
		updateInfo();
	}
	
	private void showMessage(String msg) {
    	JOptionPane.showMessageDialog(null, msg, frmSecureSoap.getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}
	
	private void doChooseFile() {
		textXMLFile.setText(getFileName());
	}
	
	private void updateInfo() {
		btnSaveSOAP.setEnabled(doc != null);
		
		if (doc == null)
			return;
		
		((SignaturesTableModel)tableSignatures.getModel()).clear();
		for (int i = 0; i < soap.getSignatureHandlerCount(); i++)
			((SignaturesTableModel)tableSignatures.getModel()).add(soap.getSignatureHandler(i));
	}
	
	private String getFileName() {
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(frmSecureSoap);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	private void doClose() {
		frmSecureSoap.setVisible(false);
	}
	
	private void doRemoveSignature() {
		int index = tableSignatures.getSelectedRow();
		if (index >= 0) {
			soap.removeSignature(index);
			updateInfo();
		}
	}
	
	private void doAddSignature() {
		if (doc == null)
			return;
		
		SignatureHandlerOptionsFrm frmSignatureHandlerOptions = new SignatureHandlerOptionsFrm();
		frmSignatureHandlerOptions.init(soap);
		frmSignatureHandlerOptions.setModal(true);
		frmSignatureHandlerOptions.setVisible(true);
		if ( ! frmSignatureHandlerOptions.isOK())
			return;
		
		TElXMLSOAPBaseSignatureHandler handler = frmSignatureHandlerOptions.addHandler(soap);
		int handlerIndex = soap.addSignature(handler, true);
		if (handler instanceof TElXMLWSSSignatureHandler) {
			int k = frmSignatureHandlerOptions.getSecurityHeaderIndex();
			if (k >= 0 && k < soap.getSecurityHeaderCount())
				((TElXMLWSSSignatureHandler)handler).setSecurityHeader(soap.getSecurityHeader(k));
		}
		
		handler.addReference(soap.getEnvelope().getBody(), true);
		
		SignatureHandlerFinalOptionsFrm frmSignatureHandlerFinalOptions = new SignatureHandlerFinalOptionsFrm();
		frmSignatureHandlerFinalOptions.init(handler);
		frmSignatureHandlerFinalOptions.setModal(true);
		frmSignatureHandlerFinalOptions.setVisible(true);
		if ( ! frmSignatureHandlerFinalOptions.isOK()) {
			soap.removeSignature(handlerIndex);
			return;
		}
		
		frmSignatureHandlerFinalOptions.applyOptions(handler);
		
		XAdESDialog xadesDialog = frmSignatureHandlerFinalOptions.getXAdESDialog();
		if (xadesDialog != null && xadesDialog.getIsEnabled()) {
			TElXAdESSigner xadesSigner = new TElXAdESSigner();
			handler.setXAdESProcessor(xadesSigner);
			
			xadesSigner.setOnBeforeCertificateValidate(new TSBXAdESBeforeCertificateValidateEvent(new TSBXAdESBeforeCertificateValidateEvent.Callback() {
				public void tsbxAdESBeforeCertificateValidateEventCallback(TObject sender, TElX509Certificate cert, TElX509CertificateValidator validator) {
					validator.setIgnoreSystemTrust(false);
					// todo
				}
			}));
			
			xadesSigner.setOnStoreCertificate(new TSBXAdESStoreCertificateEvent(new TSBXAdESStoreCertificateEvent.Callback() {
				public String tsbxAdESStoreCertificateEventCallback(TObject sender, TElX509Certificate cert) {
					try {
						String uri = "cert-" + System.currentTimeMillis() + ".cer";
						String path = new File(textXMLFile.getText()).getPath() + "/" + uri;
						
						FileOutputStream fs = new FileOutputStream(path);
						try {
							cert.saveToStream(fs);
						} finally {
							fs.close();
						}
						
						return uri;
					} catch (Exception ex) {
						ex.printStackTrace();
						return null;
					}
				}
			}));
			
			xadesSigner.setOnStoreCRL(new TSBXAdESStoreCRLEvent(new TSBXAdESStoreCRLEvent.Callback() {
				public String tsbxAdESStoreCRLEventCallback(TObject sender, TElCertificateRevocationList crl) {
					try {
						String uri = "crl-" + System.currentTimeMillis() + ".crl";
						String path = new File(textXMLFile.getText()).getPath() + "/" + uri;
						
						FileOutputStream fs = new FileOutputStream(path);
						try {
							TSBInteger sz = new TSBInteger();
							crl.saveToBuffer(null, sz);
							byte[] buf = new byte[sz.value];
							crl.saveToBuffer(buf, sz);
							buf = Arrays.copyOfRange(buf, 0, sz.value);
							
							fs.write(buf);
						} finally {
							fs.close();
						}
						
						return uri;
					} catch (Exception ex) {
						ex.printStackTrace();
						return null;
					}
				}
			}));
			
			xadesSigner.setOnStoreOCSPResponse(new TSBXAdESStoreOCSPResponseEvent(new TSBXAdESStoreOCSPResponseEvent.Callback() {
				public String tsbxAdESStoreOCSPResponseEventCallback(TObject sender, TElOCSPResponse ocsp) {
					try {
						String uri = "ocsp-" + System.currentTimeMillis() + ".ocsp";
						String path = new File(textXMLFile.getText()).getPath() + "/" + uri;
						
						FileOutputStream fs = new FileOutputStream(path);
						try {
							// todo: chekc save in TElOCSPResponse
						} finally {
							fs.close();
						}
						
						return uri;
					} catch (Exception ex) {
						ex.printStackTrace();
						return null;
					}
				}
			}));
			
			xadesDialog.applyOptions(xadesSigner, frmSignatureHandlerFinalOptions.getSigningCertificate(), doc);
		}
		
		TElX509Certificate cert = frmSignatureHandlerFinalOptions.getSigningCertificate();
		if (cert != null) {
			if (handler instanceof TElXMLSOAPSignatureHandler)
				((TElXMLSOAPSignatureHandler)handler).sign(cert, frmSignatureHandlerFinalOptions.getIncludeKey());
			else if (handler instanceof TElXMLWSSSignatureHandler)
				((TElXMLWSSSignatureHandler)handler).sign(cert, frmSignatureHandlerFinalOptions.getEmbedCertificate());
			else
				handler.sign(doc.getDocumentElement(), cert, frmSignatureHandlerFinalOptions.getIncludeKey());
		}
		
		updateInfo();
	}
}
