import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.JRadioButton;
import javax.swing.JPasswordField;
import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.XMLSecurity.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class EncDialog extends JDialog implements ActionListener {
	private static final long serialVersionUID = -98859662208879739L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edMimeType;
	private JTextField edExternalFile;
	private JTextField edKeyName;
	private JTextField edKeyFile;
	private JPasswordField edPassphrase;
	private boolean lockOpt;
	boolean isOk;
	
	JCheckBox cbEncryptKey;
	JComboBox<String> cmbEncryptedDataType;
	JComboBox<String> cmbEncryptionMethod;
	private JButton sbExternalFile;
	private JRadioButton rbKeyTransport;
	private JRadioButton rbKeyWrap;
	private JComboBox<String> cmbKeyTransport;
	private JComboBox<String> cmbKeyWrap;
	private JButton sbKeyFile;
	private JPanel rgKEK;
	private JLabel lblKeyTransport;
	private JLabel lblKeyWrap;
	private JLabel lblPassphrase;
	private JLabel lblMimeType;
	private JLabel lblExternalFile;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			EncDialog dialog = new EncDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public EncDialog() {
		setTitle("Options");
		setBounds(100, 100, 421, 608);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "General", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 393, 167);
		contentPanel.add(panel);
		panel.setLayout(null);
		{
			cbEncryptKey = new JCheckBox("Encrypt key");
			cbEncryptKey.setBounds(6, 17, 97, 23);
			panel.add(cbEncryptKey);
		}
		
		JLabel lblNewLabel = new JLabel("Encrypted data type");
		lblNewLabel.setHorizontalAlignment(SwingConstants.RIGHT);
		lblNewLabel.setBounds(6, 47, 124, 14);
		panel.add(lblNewLabel);
		
		JLabel lblNewLabel_1 = new JLabel("Encryption method");
		lblNewLabel_1.setHorizontalAlignment(SwingConstants.RIGHT);
		lblNewLabel_1.setBounds(6, 72, 124, 14);
		panel.add(lblNewLabel_1);
		
		lblMimeType = new JLabel("Mime type");
		lblMimeType.setHorizontalAlignment(SwingConstants.RIGHT);
		lblMimeType.setBounds(6, 97, 124, 14);
		panel.add(lblMimeType);
		
		lblExternalFile = new JLabel("External file");
		lblExternalFile.setHorizontalAlignment(SwingConstants.RIGHT);
		lblExternalFile.setBounds(6, 122, 124, 14);
		panel.add(lblExternalFile);

		cmbEncryptedDataType = new JComboBox<String>();
		cmbEncryptedDataType.setModel(new DefaultComboBoxModel<String>(new String[] {"Element", "Content", "External File"}));
		cmbEncryptedDataType.setBounds(140, 43, 200, 22);
		panel.add(cmbEncryptedDataType);

		cmbEncryptionMethod = new JComboBox<String>();
		cmbEncryptionMethod.setModel(new DefaultComboBoxModel<String>(new String[] {"3DES", "AES", "Camellia", "DES", "RC4"}));
		cmbEncryptionMethod.setBounds(140, 68, 200, 22);
		panel.add(cmbEncryptionMethod);
		
		edMimeType = new JTextField();
		edMimeType.setBounds(140, 94, 200, 20);
		panel.add(edMimeType);
		edMimeType.setColumns(10);
		
		edExternalFile = new JTextField();
		edExternalFile.setBounds(140, 119, 200, 20);
		panel.add(edExternalFile);
		edExternalFile.setColumns(10);
		
		sbExternalFile = new JButton("New button");
		sbExternalFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (lockOpt)
					edExternalFile.setText(getSaveFileName());
				else
					edExternalFile.setText(getFileName());
			}
		});
		sbExternalFile.setBounds(350, 118, 33, 23);
		panel.add(sbExternalFile);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, "Key Encryption Key (KEK)", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(10, 189, 393, 202);
		contentPanel.add(panel_1);
		panel_1.setLayout(null);
		
		rgKEK = new JPanel();
		rgKEK.setBorder(new TitledBorder(null, "KEK Type", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		rgKEK.setBounds(10, 27, 168, 83);
		panel_1.add(rgKEK);
		rgKEK.setLayout(null);
		
		rbKeyTransport = new JRadioButton("Key Transport");
		rbKeyTransport.setBounds(16, 20, 109, 23);
		rgKEK.add(rbKeyTransport);
		
		rbKeyWrap = new JRadioButton("Key Wrap");
		rbKeyWrap.setSelected(true);
		rbKeyWrap.setBounds(16, 46, 109, 23);
		rgKEK.add(rbKeyWrap);
		
		ButtonGroup group = new ButtonGroup();
		group.add(rbKeyWrap);
		group.add(rbKeyTransport);
		
		lblKeyTransport = new JLabel("Key Transport");
		lblKeyTransport.setHorizontalAlignment(SwingConstants.RIGHT);
		lblKeyTransport.setBounds(20, 121, 113, 14);
		panel_1.add(lblKeyTransport);
		
		lblKeyWrap = new JLabel("Key Wrap");
		lblKeyWrap.setHorizontalAlignment(SwingConstants.RIGHT);
		lblKeyWrap.setBounds(20, 146, 113, 14);
		panel_1.add(lblKeyWrap);
		
		cmbKeyTransport = new JComboBox<String>();
		cmbKeyTransport.setModel(new DefaultComboBoxModel<String>(new String[] {"RSA v1.5", "RSA-OAEP"}));
		cmbKeyTransport.setBounds(147, 117, 174, 22);
		panel_1.add(cmbKeyTransport);
		
		cmbKeyWrap = new JComboBox<String>();
		cmbKeyWrap.setModel(new DefaultComboBoxModel<String>(new String[] {"3DES", "AES 128 bit", "AES 192 bit", "AES 256 bit"}));
		cmbKeyWrap.setBounds(147, 142, 174, 22);
		panel_1.add(cmbKeyWrap);
		
		JPanel panel_3 = new JPanel();
		panel_3.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Key Info", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_3.setBounds(10, 402, 393, 135);
		contentPanel.add(panel_3);
		panel_3.setLayout(null);
		
		JLabel lblKeyName = new JLabel("Key Name");
		lblKeyName.setHorizontalAlignment(SwingConstants.RIGHT);
		lblKeyName.setBounds(10, 23, 81, 14);
		panel_3.add(lblKeyName);
		
		JLabel lblKeyFile = new JLabel("Key file");
		lblKeyFile.setHorizontalAlignment(SwingConstants.RIGHT);
		lblKeyFile.setBounds(10, 57, 81, 14);
		panel_3.add(lblKeyFile);
		
		lblPassphrase = new JLabel("Passphrase");
		lblPassphrase.setHorizontalAlignment(SwingConstants.RIGHT);
		lblPassphrase.setBounds(10, 89, 81, 14);
		panel_3.add(lblPassphrase);
		
		edKeyName = new JTextField();
		edKeyName.setBounds(101, 20, 242, 20);
		panel_3.add(edKeyName);
		edKeyName.setColumns(10);
		
		edKeyFile = new JTextField();
		edKeyFile.setBounds(101, 51, 242, 20);
		panel_3.add(edKeyFile);
		edKeyFile.setColumns(10);
		
		sbKeyFile = new JButton("New button");
		sbKeyFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				edKeyFile.setText(getFileName());
			}
		});
		sbKeyFile.setBounds(346, 50, 37, 23);
		panel_3.add(sbKeyFile);
		
		edPassphrase = new JPasswordField();
		edPassphrase.setBounds(101, 86, 242, 20);
		panel_3.add(edPassphrase);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		addListeners();
		updateOpt();
	}

	private void addListeners() {
		cbEncryptKey.addActionListener(this);
		cmbEncryptedDataType.addActionListener(this);
		rbKeyTransport.addActionListener(this);
		rbKeyWrap.addActionListener(this);
	}

	public void setLockOpt(boolean b) {
		lockOpt = b;
	}

	public boolean isOK() {
		return isOk;
	}

	public boolean getEncryptKey() {
		return cbEncryptKey.isSelected();
	}

	public short getEncryptionMethod() {
		switch (cmbEncryptionMethod.getSelectedIndex())
		{
			case 1: return SBXMLSec.xemAES;
			case 2: return SBXMLSec.xemCamellia;
			case 3: return SBXMLSec.xemDES;
			case 4: return SBXMLSec.xemRC4;
			default: return SBXMLSec.xem3DES;
		}
	}

	public String getKeyName() {
		return edKeyName.getText();
	}

	public short getEncryptedDataType() {
	    switch (cmbEncryptedDataType.getSelectedIndex())
	    {
		    case 1: return SBXMLSec.xedtContent;
		    case 2: return SBXMLSec.xedtExternal;
		    default: return SBXMLSec.xedtElement;
	    }
	}

	public short getKeyEncryptionType() {
		if (rbKeyWrap.isSelected())
			return SBXMLSec.xetKeyWrap;

		return SBXMLSec.xetKeyTransport;
	}

	public short getKeyTransportMethod() {
		if (cmbKeyTransport.getSelectedIndex() == 0)
			return SBXMLSec.xktRSA15;
		return SBXMLSec.xktRSAOAEP;
	}

	public short getKeyWrapMethod() {
		switch (cmbKeyWrap.getSelectedIndex())
		{
			case 1: return SBXMLSec.xwmAES128;
			case 2: return SBXMLSec.xwmAES192;
			case 3: return SBXMLSec.xwmAES256;
			default: return SBXMLSec.xwm3DES;
		}
	}

	public String getKeyFile() {
		return edKeyFile.getText();
	}

	public String getPassphrase() {
		return new String(edPassphrase.getPassword());
	}

	public String getMimeType() {
		return edMimeType.getText();
	}

	public String getExternalFile() {
		return edExternalFile.getText();
	}

	public void setEncryptKey(boolean b) {
		cbEncryptKey.setSelected(b);
	}

	public void setEncryptedDataType(short value) {
		switch (value)
		{
			case SBXMLSec.xedtElement: 
			{
				cmbEncryptedDataType.setSelectedIndex(0);
				break;
			}
			case SBXMLSec.xedtContent: 
			{
				cmbEncryptedDataType.setSelectedIndex(1);
				break;
			}
			case SBXMLSec.xedtExternal: 
			{
				cmbEncryptedDataType.setSelectedIndex(2);
				break;
			}
		}		
	}

	public void setEncryptionMethod(short value) {
		switch (value)
		{
			case SBXMLSec.xem3DES: 
			{
				cmbEncryptionMethod.setSelectedIndex(0);
				break;
			}
			case SBXMLSec.xemAES: 
			{
				cmbEncryptionMethod.setSelectedIndex(1);
				break;
			}
			case SBXMLSec.xemCamellia: 
			{
				cmbEncryptionMethod.setSelectedIndex(2);
				break;
			}
			case SBXMLSec.xemDES: 
			{
				cmbEncryptionMethod.setSelectedIndex(3);
				break;
			}
			case SBXMLSec.xemRC4: 
			{
				cmbEncryptionMethod.setSelectedIndex(4);
				break;
			}
		}
	}

	public void setKeyEncryptionType(short value) {
		if (value == SBXMLSec.xetKeyTransport)
			rbKeyTransport.setSelected(true);
		else
			rbKeyWrap.setSelected(true);
	}

	public void setKeyTransportMethod(short value) {
		if (value == SBXMLSec.xktRSA15)
			cmbKeyTransport.setSelectedIndex(0);
		else
			cmbKeyTransport.setSelectedIndex(1);		
	}

	public void setKeyWrapMethod(short value) {
		switch (value)
		{
			case SBXMLSec.xwm3DES: 
			{
				cmbKeyWrap.setSelectedIndex(0);
				break;
			}
			case SBXMLSec.xwmAES128: 
			{
				cmbKeyWrap.setSelectedIndex(1);
				break;
			}
			case SBXMLSec.xwmAES192: 
			{
				cmbKeyWrap.setSelectedIndex(2);
				break;
			}
			case SBXMLSec.xwmAES256: 
			{
				cmbKeyWrap.setSelectedIndex(3);
				break;
			}
		}		
	}

	public void setKeyName(String value) {
		edKeyName.setText(value);
	}

	public void setMimeType(String value) {
		edMimeType.setText(value);
	}

	public void updateOpt() {
		rgKEK.setEnabled(cbEncryptKey.isSelected());
		cmbKeyTransport.setEnabled(cbEncryptKey.isSelected());
		lblKeyTransport.setEnabled(cmbKeyTransport.isEnabled());
		cmbKeyWrap.setEnabled(cbEncryptKey.isSelected());
		lblKeyWrap.setEnabled(cmbKeyWrap.isEnabled());
		cmbKeyTransport.setEnabled(cbEncryptKey.isSelected() && rbKeyTransport.isSelected());
		lblKeyTransport.setEnabled(cmbKeyTransport.isEnabled());
		cmbKeyWrap.setEnabled(cbEncryptKey.isSelected() && rbKeyWrap.isSelected());
		lblKeyWrap.setEnabled(cmbKeyWrap.isEnabled());
		edPassphrase.setEnabled(cmbKeyTransport.isEnabled());
		lblPassphrase.setEnabled(edPassphrase.isEnabled());
		edMimeType.setEnabled(cmbEncryptedDataType.getSelectedIndex() == 2);
		lblMimeType.setEnabled(edMimeType.isEnabled());
		edExternalFile.setEnabled(cmbEncryptedDataType.getSelectedIndex() == 2);
		lblExternalFile.setEnabled(edExternalFile.isEnabled());
		sbExternalFile.setEnabled(edExternalFile.isEnabled());
	}
	
	String getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	public void actionPerformed(ActionEvent e) {
		updateOpt();
	} 
}
