

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.JTextArea;
import javax.swing.border.LineBorder;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.HTTPClient.TElHTTPSClient;
import SecureBlackbox.HTTPClient.TElHTTPTSPClient;
import SecureBlackbox.PGP.TElPGPPublicKey;
import SecureBlackbox.PGP.TElPGPSecretKey;
import SecureBlackbox.XML.*;
import SecureBlackbox.XMLSecurity.*;

import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.FileInputStream;
import java.util.Date;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
	  
class Main extends JDialog {
	private static final long serialVersionUID = -8938687539889635131L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edXMLFile;
	private TElXMLDOMDocument FXMLDocument = null;
	JTextArea mmXML;
	JTree tvXML;
	DefaultMutableTreeNode rootNode;
	JLabel lNodeType;
	JLabel lNamespace;
	SignDialog frmSign;
	private TElX509CertificateValidator CertificateValidator;
	private JComboBox<String> cbCharset;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");

		JNI.initialize();
		
		setTitle("Simple Signer");
		FXMLDocument = new TElXMLDOMDocument();
		rootNode = new DefaultMutableTreeNode(FXMLDocument.getNodeName());
		rootNode.setUserObject(new NodeData(FXMLDocument, FXMLDocument.getNodeName()));
		frmSign = new SignDialog();
		CertificateValidator = new TElX509CertificateValidator();
		
		setBounds(100, 100, 454, 611);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblXmlFile = new JLabel("XML File");
		lblXmlFile.setBounds(10, 11, 61, 14);
		contentPanel.add(lblXmlFile);
		
		edXMLFile = new JTextField();
		edXMLFile.setBounds(74, 8, 321, 20);
		contentPanel.add(edXMLFile);
		edXMLFile.setColumns(10);
		
		JButton sbBrowseXMLFile = new JButton(".");
		sbBrowseXMLFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				edXMLFile.setText(getXMLFileName());
			}
		});
		sbBrowseXMLFile.setBounds(405, 7, 29, 23);
		contentPanel.add(sbBrowseXMLFile);
		
		tvXML = new JTree(rootNode);
		tvXML.setBorder(new LineBorder(new Color(0, 0, 0)));
		tvXML.setBounds(10, 71, 321, 323);
		tvXML.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent e) {
				onNodeSelect();
			}
		});
		contentPanel.add(tvXML);
		
		JButton btnLoadXml = new JButton("Load XML");
		btnLoadXml.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				loadXML(edXMLFile.getText());
			}
		});
		btnLoadXml.setBounds(341, 71, 91, 23);
		contentPanel.add(btnLoadXml);
		
		JButton btnSaveXml = new JButton("Save XML");
		btnSaveXml.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveXML();
			}
		});
		btnSaveXml.setBounds(341, 98, 91, 23);
		contentPanel.add(btnSaveXml);
		
		JButton btnDelete = new JButton("Delete");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				deleteSelectedNodes();
			}
		});
		btnDelete.setBounds(341, 199, 91, 23);
		contentPanel.add(btnDelete);
		
		JButton btnClear = new JButton("Clear");
		btnClear.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				clear();
			}
		});
		btnClear.setBounds(341, 233, 91, 23);
		contentPanel.add(btnClear);
		
		JButton btnEncrypt = new JButton("Sign");
		btnEncrypt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				sign();
			}
		});
		btnEncrypt.setBounds(341, 288, 91, 23);
		contentPanel.add(btnEncrypt);
		
		JButton btnDecrypt = new JButton("Verify");
		btnDecrypt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				verify();
			}
		});
		btnDecrypt.setBounds(343, 322, 91, 23);
		contentPanel.add(btnDecrypt);
		
		JLabel lblNodeType = new JLabel("Node type:");
		lblNodeType.setBounds(10, 405, 96, 14);
		contentPanel.add(lblNodeType);
		
		JLabel lblNamespaceUri = new JLabel("Namespace URI:");
		lblNamespaceUri.setBounds(10, 430, 96, 14);
		contentPanel.add(lblNamespaceUri);
		
		mmXML = new JTextArea();
		mmXML.setBorder(new LineBorder(new Color(0, 0, 0)));
		mmXML.setBounds(10, 455, 424, 85);
		contentPanel.add(mmXML);
		
		lNamespace = new JLabel(" ");
		lNamespace.setBounds(98, 430, 336, 14);
		contentPanel.add(lNamespace);
		
		lNodeType = new JLabel(" ");
		lNodeType.setBounds(98, 405, 336, 14);
		contentPanel.add(lNodeType);
		
		JButton btnRemove = new JButton("Remove");
		btnRemove.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				remove();
			}
		});
		btnRemove.setBounds(343, 356, 91, 23);
		contentPanel.add(btnRemove);
		
		JCheckBox chckbxNormalizeNewlineCharacters = new JCheckBox("Normalize newline characters on load");
		chckbxNormalizeNewlineCharacters.setSelected(true);
		chckbxNormalizeNewlineCharacters.setBounds(10, 41, 257, 23);
		contentPanel.add(chckbxNormalizeNewlineCharacters);
		
		cbCharset = new JComboBox<String>();
		cbCharset.setBounds(341, 39, 93, 22);
		contentPanel.add(cbCharset);
		SBChSConv.enumCharsets(new TEnumCharsetsProc(enumClb), cbCharset);
		
		JLabel lblCharset = new JLabel("Charset");
		lblCharset.setBounds(280, 46, 51, 14);
		contentPanel.add(lblCharset);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected void remove() {
        TElXMLVerifier Verifier;
        TElXMLDOMNode selectedNode, Node, T;
	    
        TreePath[] paths = tvXML.getSelectionPaths();
		if (paths.length == 0)
		{
			selectedNode = getFirstNode(paths);
			
	        if (selectedNode != null)
	            Node = (TElXMLDOMNode)selectedNode;
	        else
	            Node = (TElXMLDOMNode)FXMLDocument;
	
	        T = Node;
	        while ((T instanceof TElXMLDOMElement) &&
	            (((TElXMLDOMElement)T).getLocalName() != "Signature") &&
	            (T.getParentNode() != null))
	            T = T.getParentNode();
	
	        if (!(T instanceof TElXMLDOMDocument))
	            Node = T;
	
	        if (Node instanceof TElXMLDOMDocument)
	            T = ((TElXMLDOMDocument)Node).getDocumentElement();
	        else
	            T = Node;
	
	        if (!(T instanceof TElXMLDOMElement) ||
	            ((((TElXMLDOMElement)T).getLocalName() != "Signature") &&
	            (SBXMLUtils.findElementByName((TElXMLDOMElement)T, "Signature", SBXMLDefs.xmlSignatureNamespace)) == null))
	        {
	            showMessage("", "Please, select Signature element for removing.");
	            return;
	        }

	        Verifier = new TElXMLVerifier();
	        try
	        {
	            try
	            {
	                Verifier.load((TElXMLDOMElement)T);
	            }
	            catch (Exception E)
	            {
	            	E.printStackTrace();
	                showErrorMessage("Signature data loading failed." + E.getMessage());
	                return;
	            }
	
	            Verifier.removeSignature();
	        }
	        finally
	        {
	            Verifier.Destroy();
	        }
	
	        updateXML();
		}
	}

	protected void verify() {
        TElXMLVerifier Verifier;
        TElXAdESVerifier XAdESVerifier;
        TElXMLKeyInfoHMACData HMACKeyData = null;
        TElXMLKeyInfoRSAData RSAKeyData = null;
        TElXMLKeyInfoX509Data X509KeyData = null;
        TElXMLKeyInfoPGPData PGPKeyData = null;
        TElFileStream F;
        FileInputStream FI;
        byte[] Buf;
        TElXMLDOMNode selectedNode, Node, T;
        TElX509Certificate Cert;
        TSBCertificateValidity Validity = TSBCertificateValidity.cvInvalid;
        Date SigningTime = new Date();

        TreePath[] paths = tvXML.getSelectionPaths();
		if (paths.length > 0)
		{
			selectedNode = getFirstNode(paths);
			
	        if (selectedNode != null)
	            Node = (TElXMLDOMNode)selectedNode;
	        else
	            Node = (TElXMLDOMNode)FXMLDocument;

	        T = Node;
	        while ((T instanceof TElXMLDOMElement) &&
	            (((TElXMLDOMElement)T).getLocalName() != "Signature") &&
	            (T.getParentNode() != null))
	            T = T.getParentNode();
	
	        if (!(T instanceof TElXMLDOMDocument))
	            Node = T;
	
	        if (Node instanceof TElXMLDOMDocument)
	            T = ((TElXMLDOMDocument)Node).getDocumentElement();
	        else
	            T = Node;
	
	        if (!(T instanceof TElXMLDOMElement) ||
	            ((((TElXMLDOMElement)T).getLocalName() != "Signature") &&
	            (SBXMLUtils.findElementByName((TElXMLDOMElement)T, "Signature", SBXMLDefs.xmlSignatureNamespace)) == null))
	        {
	            showMessage("", "Please, select Signature element for verifying.");
	            return;
	        }
	
	        Verifier = new TElXMLVerifier();
	        XAdESVerifier = new TElXAdESVerifier();

	        Verifier.setXAdESProcessor(XAdESVerifier);
	        try
	        {
	            try
	            {
	                Verifier.load((TElXMLDOMElement)T);
	            }
	            catch (Exception E)
	            {
	            	E.printStackTrace();
	                showErrorMessage("Signature data loading failed. " + E.getMessage());
	                return;
	            }
	
	            for (int i = 0; i < Verifier.getReferences().getCount(); i++) // this code is unnecessary, it shows how to process application specific URI
	            {
	                TElXMLReference Ref = Verifier.getReferences().getReference(i);
	                if (Ref.getURINode() == null)
	                {
	                    if (Ref.getURI().compareTo("") == 0)
	                        Ref.setURINode(FXMLDocument.getDocumentElement());
	                    else
	                    {
	                        try
	                        {
	                            String s = SBXMLUtils.extractIdFromLocalURI(Ref.getURI());
	                            if (s.compareTo("") != 0)
	                                Ref.setURINode(SBXMLUtils.findElementById(FXMLDocument.getDocumentElement(), s));
	                        }
	                        catch (Exception E) { }
	                    }
	                }
	            }
	
		        frmSign.setReferenceDocument(FXMLDocument);
		        frmSign.setReferences(Verifier.getReferences());
		        frmSign.setReferencesVerify(true);
		        frmSign.setIncludeKey(false);
		
	            if ((XAdESVerifier != null) && XAdESVerifier.getIsEnabled())
	            {
	                frmSign.frmXAdES.setVerify(true);
	                frmSign.frmXAdES.setChecked(true);
	
	                switch (XAdESVerifier.getXAdESVersion())
	                {
	                    case SBXMLAdES.XAdES_v1_1_1:
	                        {
	                            frmSign.frmXAdES.setVersionSelectedIndex(0);
	                            break;
	                        }
	                    case SBXMLAdES.XAdES_v1_2_2:
	                        {
	                            frmSign.frmXAdES.setVersionSelectedIndex(1);
	                            break;
	                        }
	                    case SBXMLAdES.XAdES_v1_3_2:
	                        {
	                            frmSign.frmXAdES.setVersionSelectedIndex(2);
	                            break;
	                        }
	                    default:
	                        {
	                            frmSign.frmXAdES.setVersionSelectedIndex(-1);
	                            break;
	                        }
	                }
	
	                if (XAdESVerifier.getPolicyId() != null)
	                {
	                    frmSign.frmXAdES.setDescriptionText(XAdESVerifier.getPolicyId().getSigPolicyId().getDescription());
	                    frmSign.frmXAdES.setDocumentationReferenceText(XAdESVerifier.getPolicyId().getSigPolicyId().getDocumentationReferences().getText());
	                    frmSign.frmXAdES.setIdentifierText(XAdESVerifier.getPolicyId().getSigPolicyId().getIdentifier());
	                }
	                else
	                {
	                    frmSign.frmXAdES.setDescriptionText("");
	                    frmSign.frmXAdES.setDocumentationReferenceText("");
	                    frmSign.frmXAdES.setIdentifierText("");
	                }
	
	                if ((XAdESVerifier.getIncluded() & SBXMLAdESIntf.xipProductionPlace) > 0)
	                {
	                    frmSign.frmXAdES.setProductionPlaceChecked(true);
	                    frmSign.frmXAdES.setCountryText(XAdESVerifier.getProductionPlace().getCountryName());
	                    frmSign.frmXAdES.setStateOrProvinceText(XAdESVerifier.getProductionPlace().getStateOrProvince());
	                    frmSign.frmXAdES.setPostalCodeText(XAdESVerifier.getProductionPlace().getPostalCode());
	                    frmSign.frmXAdES.setCityText(XAdESVerifier.getProductionPlace().getCity());
	                }
	                else
	                    frmSign.frmXAdES.setProductionPlaceChecked(false);
	
	                if (XAdESVerifier.getSigningTime() != new Date(0))
	                    frmSign.frmXAdES.setSignedTimeText("Signed Time: " + XAdESVerifier.getSigningTime() + " UTC");
	                else
	                    frmSign.frmXAdES.setSignedTimeText("");
	
	                SigningTime = XAdESVerifier.getSigningTime();
	                if (XAdESVerifier.getTimestamp() != null)
	                {
	
	                    if (XAdESVerifier.checkTimestamp(XAdESVerifier.getTimestamp()))
	                    {
	                        // First we need to validate time stamp signature
	                        Cert = XAdESVerifier.getTimestamp().getSignerCertificate();
	                        if (Cert != null)
	                        {
	                        	TElX509CertificateValidatorResult result = new TElX509CertificateValidatorResult();
	                            CertificateValidator.validate(Cert, XAdESVerifier.getTimestamp().getCertificates(), false, XAdESVerifier.getTimestamp().getTime(), result);
	                        }
	                        else
	                            Validity = TSBCertificateValidity.cvOk;
	
	                        // Now show time stamping information
	                        if (Validity == TSBCertificateValidity.cvOk)
	                        {
	                            frmSign.frmXAdES.setTimestampText("Timestamp: " + XAdESVerifier.getTimestamp() + " UTC");
	                            frmSign.frmXAdES.setTimestampSerialText("Timestamp Serial: " +
	                            SBUtils.beautifyBinaryString(SBUtils.binaryToString(XAdESVerifier.getTimestamp().getSerialNumber()), ':'));
	                        }
	                        else
	                        {
	                            frmSign.frmXAdES.setTimestampText("Timestamp signature is not valid");
	                            frmSign.frmXAdES.setTimestampSerialText("");
	                        }
	                    }
	                    else
	                    {
	                        frmSign.frmXAdES.setTimestampText("INVALID SIGNATURE TIMESTAMP");
	                        frmSign.frmXAdES.setTimestampSerialText("");
	                    }
	                }
	                else
	                {
	                    frmSign.frmXAdES.setTimestampText("");
	                    frmSign.frmXAdES.setTimestampSerialText("");
	                }
	
	                frmSign.frmXAdES.setCertIDs(XAdESVerifier.getQualifyingProperties().getSignedProperties().getSignedSignatureProperties().getSigningCertificate());
	            }
	
	            Boolean SigOK = true;
	
	            if (!Verifier.validateSignature())
	            {
	            	String keyFile = frmSign.getKeyFile();

	                // KeyInfo doesn't contain correct public key for the signature
	                // or data corrupted
	
	                frmSign.setCanonicalizationMethod(Verifier.getCanonicalizationMethod());
	                //frmSign.SignatureType = Verifier.SignatureType;
	                frmSign.setSignatureTypeText("");
	                frmSign.setSignatureMethodType(Verifier.getSignatureMethodType());
	                frmSign.setSigMethod(Verifier.getSignatureMethod());
	                frmSign.setHMACMethod(Verifier.getMACMethod());
	                frmSign.setKeyName(Verifier.getKeyName());
	
	                Cert = frmSign.frmSelWinCert.getSelWinCertificate();
	                frmSign.setModal(true);
	                frmSign.setVisible(true);
	                
	                if (frmSign.isOK())
	                {
	                    frmSign.setSignatureType(Verifier.getSignatureType());
	
	                    if (Verifier.getSignatureMethodType() == SBXMLSec.xmtMAC)
	                    {
	                        HMACKeyData = new TElXMLKeyInfoHMACData(true);
	
	                        try
	                        {
	                            F = new TElFileStream(keyFile, "rw", true);
	                        }
	                        catch (Exception E)
	                        {
	                        	E.printStackTrace();
	                            showErrorMessage("Error: " + E.getMessage());
	                            return;
	                        }
	
	                        Buf = new byte[(int)F.getLength()];
	                        if (F.getLength() > 0)
	                            F.read(Buf, 0, (int)F.getLength());
	
	                        F.Destroy();
	                        HMACKeyData.getKey().setKey(Buf);
	                        Verifier.setHMACKey(HMACKeyData);
	                    }
	                    else
	                    {
	                        if (Cert != null)
	                        {
	                            X509KeyData = new TElXMLKeyInfoX509Data(false);
	                            X509KeyData.setCertificate(Cert);
	                            Verifier.setKeyData(X509KeyData);
	                        }
	                        else
	                        {
	                            RSAKeyData = new TElXMLKeyInfoRSAData(true);
	                            RSAKeyData.getRSAKeyMaterial().setPassphrase(frmSign.getPassphrase());
	                            X509KeyData = new TElXMLKeyInfoX509Data(true);
	                            PGPKeyData = new TElXMLKeyInfoPGPData(true);
	
	                            try
	                            {
	                            	F = new TElFileStream(keyFile, "rw", true);
	                                FI = new FileInputStream(keyFile);
	                            }
	                            catch (Exception E)
	                            {
	                            	E.printStackTrace();
	                                showErrorMessage("Error: " + E.getMessage());
	                                return;
	                            }
	
	                            try
	                            {
	                                RSAKeyData.getRSAKeyMaterial().loadPublic(FI, 0);
	                            }
	                            catch (Exception E) { }
	
	                            if (!RSAKeyData.getRSAKeyMaterial().getPublicKey())
	                            {
	                                try
	                                {
	                                    RSAKeyData.getRSAKeyMaterial().loadSecret(FI, 0);
	                                }
	                                catch (Exception E) { }
	                            }
	
	                            if (!RSAKeyData.getRSAKeyMaterial().getPublicKey())
	                            {
	                                LoadCertificate(FI, keyFile, frmSign.getPassphrase(), X509KeyData);
	                            }
	
	                            if (!RSAKeyData.getRSAKeyMaterial().getPublicKey() &&
	                                (X509KeyData.getCertificate() == null))
	                            {
	                            	TElPGPPublicKey pubKey = new TElPGPPublicKey();
	                                try
	                                {
	    	                            FI.close();
	                                    pubKey.loadFromStream(F);
		                                PGPKeyData.setPublicKey(pubKey);
	                                }
	                                catch (Exception E)
	                                {
	                                    PGPKeyData.getPublicKey().Destroy();
	                                    PGPKeyData.setPublicKey(null);
	                                }
	
	                                if (PGPKeyData.getPublicKey() == null)
	                                {
	                                	TElPGPSecretKey secKey = new TElPGPSecretKey();
	                                    PGPKeyData.getSecretKey().setPassphrase(frmSign.getPassphrase());
	                                    try
	                                    {
	                                        secKey.loadFromStream(F);
		                                    PGPKeyData.setSecretKey(secKey);

	                                    }
	                                    catch (Exception E)
	                                    {
	                                        PGPKeyData.setSecretKey(null);
	                                    }
	                                }
	                            }
	
	                            F.Destroy();
	                            
	                            if (RSAKeyData.getRSAKeyMaterial().getPublicKey())
	                                Verifier.setKeyData(RSAKeyData);
	                            else
	                                if (X509KeyData.getCertificate() != null)
	                                    Verifier.setKeyData(X509KeyData);
	                                else
	                                    if ((PGPKeyData.getPublicKey() != null) || (PGPKeyData.getSecretKey() != null))
	                                        Verifier.setKeyData(PGPKeyData);
	                                    else
	                                    {
	                                        showErrorMessage("Key not loaded.");
	                                        return;
	                                    }
	                        }
	                    }
	
	                    if (!Verifier.validateSignature())
	                    {
	                        SigOK = false;
	                        showMessage("", "Signature is invalid");
	                    }
	                    else
	                        if ((Verifier.getKeyData() instanceof TElXMLKeyInfoX509Data) &&
	                            ((TElXMLKeyInfoX509Data)Verifier.getKeyData()).getCertificate() != null)
	                        {
	                        	TElX509CertificateValidatorResult result = new TElX509CertificateValidatorResult();
	                            CertificateValidator.validate(((TElXMLKeyInfoX509Data)Verifier.getKeyData()).getCertificate(), ((TElXMLKeyInfoX509Data)Verifier.getKeyData()).getCertStorage(), false, SigningTime, result);
	                            if (Validity == TSBCertificateValidity.cvSelfSigned)
	                                showMessage("Success", "The selected signature is signed by self-signed certificate which was not previously trusted");
	                            else if (Validity != TSBCertificateValidity.cvOk)
	                            {
	                                //SigOK = false;
	                                if (Validity == TSBCertificateValidity.cvChainUnvalidated)
	                                    showMessage("", "Signing certificate chain could not be validated completely.");
	                                else
	                                    showErrorMessage("Signing certificate is not valid.");
	                            }
	                        }
	                }
	                else
	                    SigOK = false;
	            }
	            else
	            {
	                // signature is valid
	                // validate a certificate used for signature validation
	                if (Verifier.getSignerCertificate() != null)
	                {
	                	TElX509CertificateValidatorResult result = new TElX509CertificateValidatorResult();
	                    CertificateValidator.validate(Verifier.getSignerCertificate(), ((TElXMLKeyInfoX509Data)Verifier.getSignerKeyData()).getCertStorage(), false, SigningTime, result);
	                    if (Validity == TSBCertificateValidity.cvSelfSigned)
	                        showMessage("Success", "The selected signature is signed by self-signed certificate which was not previously trusted");
	                    else if (Validity != TSBCertificateValidity.cvOk)
	                    {
	                        //SigOK = false;
	                        if (Validity == TSBCertificateValidity.cvChainUnvalidated)
	                            showErrorMessage("Signing certificate chain could not be validated completely.");
	                        else
	                            showErrorMessage("Signing certificate is not valid.");
	                    }
	                }
	            }
	
	            if (SigOK)
	            {
	                if (Verifier.validateReferences())
	                    showMessage("", "Signature and refences validated successfully.");
	                else
	                    if (chooseMessage("Signature validated successfully.\r\nDo you want to validate references?"))
	                        frmSign.showReferencesDialog();
	
	                if ((XAdESVerifier != null) && XAdESVerifier.getIsEnabled())
	                {
	                    if (chooseMessage("Do you want to view XAdES information?"))
	                        frmSign.showXAdESDialog();
	                }
	            }
	        }
	        finally
	        {
	            Verifier.Destroy();
	            XAdESVerifier.Destroy();
	            if (X509KeyData != null)
	                X509KeyData.Destroy();
	            if (PGPKeyData != null)
	                PGPKeyData.Destroy();
	        }
		}
	}

	private boolean chooseMessage(String msg) {
		return (JOptionPane.showConfirmDialog(this, msg) == JOptionPane.YES_OPTION);
	}

	protected void sign() {
        TElXMLSigner Signer;
        TElXAdESSigner XAdESSigner = null;
        TElXMLKeyInfoHMACData HMACKeyData = null;
        TElXMLKeyInfoRSAData RSAKeyData = null;
        TElXMLKeyInfoX509Data X509KeyData = null;
        TElXMLKeyInfoPGPData PGPKeyData = null;
        TElFileStream F;
        FileInputStream FI;
        TElXMLDOMNode SigNode;
        TElXMLDOMNode selectedNode;
        byte[] Buf;
        TElXMLReference Ref = null;
        TElXMLReferenceList Refs = new TElXMLReferenceList();
        TElHTTPSClient HTTPClient = null;
        TElHTTPTSPClient TSPClient = null;
		
	    TreePath[] paths = tvXML.getSelectionPaths();

		if (paths.length > 0)
		{
			selectedNode = getFirstNode(paths);

	        if (selectedNode != null)
	        {
	            Ref = new TElXMLReference();
	            Ref.setDigestMethod(SBXMLSec.xdmSHA1);
	            if (selectedNode instanceof TElXMLDOMDocument)
	            {
	            	Ref.setURI("");
	                Ref.setURINode(((TElXMLDOMDocument)selectedNode).getDocumentElement());
	            }
	            else
	                if (selectedNode instanceof TElXMLDOMElement)
	                {
	                    Ref.setURINode((TElXMLDOMNode)selectedNode);
	                    TElXMLDOMElement El = (TElXMLDOMElement)selectedNode;
	                    if (El.getAttribute("Id") != "")
	                        Ref.setURI("#" + El.getAttribute("Id"));
	                    else
	                        if (El.getParentNode() instanceof TElXMLDOMDocument)
	                            Ref.setURI("");
	                        else
	                        {
	                            El.setAttribute("Id", "id-" + SBStrUtils.intToStr(SBRandom.sbRndGenerate(Integer.MAX_VALUE)));
	                            Ref.setURI("#" + El.getAttribute("Id"));
	                        }
	                }
	                else
	                {
	                    Ref.setURINode(selectedNode);
	                    Ref.setURI(selectedNode.getLocalName());
	                }
	
	            Ref.getTransformChain().add(new TElXMLEnvelopedSignatureTransform());
	            Refs.add(Ref);
	        }
	
	        frmSign.setReferenceDocument(FXMLDocument);
	        frmSign.setReferences(Refs);
	        frmSign.setReferencesVerify(false);
	        frmSign.setIncludeKey(true);
	        frmSign.frmXAdES.setVerify(false);
	
	        frmSign.setModal(true);
	        frmSign.setVisible(true);
	        
	        if (frmSign.isOK())
	        {
	            Signer = new TElXMLSigner();
	            try
	            {
	                Signer.setSignatureType(frmSign.getSignatureType());
	                Signer.setCanonicalizationMethod(frmSign.getCanonicalizationMethod());
	                Signer.setSignatureMethodType(frmSign.getSignatureMethodType());
	                Signer.setSignatureMethod(frmSign.getSigMethod());
	                Signer.setMACMethod(frmSign.getHMACMethod());
	                Signer.setReferences(Refs);
	                Signer.setKeyName(frmSign.getKeyName());
	                Signer.setIncludeKey(frmSign.getIncludeKey());
	
	                Signer.setOnFormatElement(new TSBXMLFormatElementEvent(formatElementClb));
	                Signer.setOnFormatText(new TSBXMLFormatTextEvent(formatTextClb));
	
	                TElX509Certificate Cert = frmSign.frmSelWinCert.getSelWinCertificate();
	
	                if ((Signer.getSignatureType() == SBXMLSec.xstEnveloping) && (Ref != null) && (Ref.getURI().compareTo("") == 0) && (Ref.getURINode() instanceof TElXMLDOMElement))
	                {
	                    TElXMLDOMElement El = (TElXMLDOMElement)Ref.getURINode();
	                    El.setAttribute("Id", "id-" + SBStrUtils.intToStr(SBRandom.sbRndGenerate(Integer.MAX_VALUE)));
	                    Ref.setURI("#" + El.getAttribute("Id"));
	                }
	
	                if (Signer.getSignatureMethodType() == SBXMLSec.xmtMAC)
	                {
	                    HMACKeyData = new TElXMLKeyInfoHMACData(true);
	
    		        	String keyFile = frmSign.getKeyFile();
    		        	if (keyFile.compareTo("") == 0) throw new Exception("Please specify key file...");

	                    try
	                    {
	                        F = new TElFileStream(keyFile, "rw", true);
	                    }
	                    catch (Exception E)
	                    {
	                    	E.printStackTrace();
	                        showErrorMessage(E.getMessage());
	                        return;
	                    }
	
	                    Buf = new byte[(int)F.getLength()];
	                    if (F.getLength() > 0)
	                        F.read(Buf, 0, (int)F.getLength());
	
	                    F.Destroy();
	                    HMACKeyData.getKey().setKey(Buf);
	                    Signer.setKeyData(HMACKeyData);
	                }
	                else
	                {
	                    if ((Cert != null) && Cert.getPrivateKeyExists())
	                    {
	                        X509KeyData = new TElXMLKeyInfoX509Data(false);
	                        X509KeyData.setCertificate(Cert);
	                        Signer.setKeyData(X509KeyData);
	                    }
	                    else
	                    {
	                        RSAKeyData = new TElXMLKeyInfoRSAData(true);
	                        RSAKeyData.getRSAKeyMaterial().setPassphrase(frmSign.getPassphrase());
	                        X509KeyData = new TElXMLKeyInfoX509Data(true);
	                        PGPKeyData = new TElXMLKeyInfoPGPData(true);
	
	    		        	String keyFile = frmSign.getKeyFile();
	    		        	if (keyFile.compareTo("") == 0) throw new Exception("Please specify key file...");
	    		        	
	                        try
	                        {
	                            FI = new FileInputStream(keyFile);
	                        }
	                        catch (Exception E)
	                        {
	                        	E.printStackTrace();
	                            showErrorMessage(E.getMessage());
	                            return;
	                        }
	
	                        try
	                        {
	                            RSAKeyData.getRSAKeyMaterial().loadSecret(FI, 0);
	                        }
	                        catch (Exception E) { 
	                        	E.printStackTrace();
	                        }
	
	                        if (!RSAKeyData.getRSAKeyMaterial().getSecretKey())
	                        {
	                            LoadCertificate(FI, keyFile, frmSign.getPassphrase(), X509KeyData); // ToDo check 2 parameter 
	                        }
	
	                        if (!RSAKeyData.getRSAKeyMaterial().getPublicKey() &&
	                            (X509KeyData.getCertificate() == null))
	                        {
	                        	TElPGPSecretKey secKey = new TElPGPSecretKey();

	                            secKey.setPassphrase(frmSign.getPassphrase());
	                            try
	                            {
	                            	F = new TElFileStream(keyFile, "rw", true);
	                                secKey.loadFromStream(F);
		                            PGPKeyData.setSecretKey(secKey);
	                                F.Destroy();
	                            }
	                            catch(Exception E)
	                            {
	                                PGPKeyData.setSecretKey(null);
	                            }
	                        }
	
	                        FI.close();
	
	                        if (RSAKeyData.getRSAKeyMaterial().getSecretKey())
	                            Signer.setKeyData(RSAKeyData);
	                        else
	                            if (X509KeyData.getCertificate() != null)
	                                Signer.setKeyData(X509KeyData);
	                            else
	                                if (PGPKeyData.getSecretKey() != null)
	                                    Signer.setKeyData(PGPKeyData);
	                                else
	                                {
	                                    showMessage("", "Key not loaded.");
	                                    return;
	                                }
	                    }
	                }
	
	                if (frmSign.frmXAdES.getIsEnabled())
	                {
	                    XAdESSigner = new TElXAdESSigner();
	                    Signer.setXAdESProcessor(XAdESSigner);
	
	                    switch (frmSign.frmXAdES.getVersionSelectedIndex())
	                    {
	                        case 0:
	                            {
	                                XAdESSigner.setXAdESVersion(SBXMLAdES.XAdES_v1_1_1);
	                                break;
	                            }
	                        case 1:
	                            {
	                                XAdESSigner.setXAdESVersion(SBXMLAdES.XAdES_v1_2_2);
	                                break;
	                            }
	                        default:
	                            {
	                                XAdESSigner.setXAdESVersion(SBXMLAdES.XAdES_v1_3_2);
	                                break;
	                            }
	                    }
	
	                    XAdESSigner.getPolicyId().getSigPolicyId().setDescription(frmSign.frmXAdES.getDescription());
	                    if (frmSign.frmXAdES.getDocumentationReferenceText().compareTo("") != 0)
	                        XAdESSigner.getPolicyId().getSigPolicyId().getDocumentationReferences().add(frmSign.frmXAdES.getDocumentationReferenceText());
	                    String s = frmSign.frmXAdES.getIdentifierText();
	                    XAdESSigner.getPolicyId().getSigPolicyId().setIdentifier(s);
	                    if (s.length() > 0)
	                    {
	                        if (s.toLowerCase().startsWith("urn:"))
	                            XAdESSigner.getPolicyId().getSigPolicyId().setIdentifierQualifier(SBXMLAdES.xqtOIDAsURN);
	                        else
	                            XAdESSigner.getPolicyId().getSigPolicyId().setIdentifierQualifier(SBXMLAdES.xqtOIDAsURI);
	                    }
	                    else
	                        XAdESSigner.getPolicyId().getSigPolicyId().setIdentifierQualifier(SBXMLAdES.xqtNone);
	
	                    if (frmSign.frmXAdES.getProductionPlaceChecked())
	                    {
	                        XAdESSigner.setIncluded(SBXMLAdESIntf.xipProductionPlace);
	                        XAdESSigner.getProductionPlace().setCity(frmSign.frmXAdES.getCityText());
	                        XAdESSigner.getProductionPlace().setStateOrProvince(frmSign.frmXAdES.getStateOrProvinceText());
	                        XAdESSigner.getProductionPlace().setPostalCode(frmSign.frmXAdES.getPostalCodeText());
	                        XAdESSigner.getProductionPlace().setCountryName(frmSign.frmXAdES.getCountryText());
	                    }
	
	                    if (frmSign.frmXAdES.getTimestampChecked())
	                    {
	                        TSPClient = new TElHTTPTSPClient();
	                        HTTPClient = new TElHTTPSClient();
	                        TSPClient.setHTTPClient(HTTPClient);
	                        TSPClient.setURL(frmSign.frmXAdES.getTimestampServerText());
	                        TSPClient.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_SHA1);
	                        XAdESSigner.setTSPClient(TSPClient);
	                        XAdESSigner.setIgnoreTimestampFailure(false);
	                    }
	
	                    XAdESSigner.setSigningCertificates(frmSign.frmXAdES.getCertStorage());
	
	                    XAdESSigner.setSigningTime(new Date());
	
	                    // create XAdESSigner.QualifyingProperties
	                    XAdESSigner.generate();
	
	                    // Finally we can modify QualifyingProperties if needed
	                    // For example set xades prefix:
	                    XAdESSigner.getQualifyingProperties().setXAdESPrefix("xades");
	                }
	
	                Signer.updateReferencesDigest();
	
	                if (Signer.getSignatureType() == SBXMLSec.xstDetached)
	                {
	                    Signer.generateSignature();
	
	                    FXMLDocument.Destroy();
	                    try
	                    {
	                        SigNode = null;
	                        TSBObject obj = new TSBObject();
	                        Signer.save(obj);
	                        SigNode = (TElXMLDOMNode)obj.value;
	                        FXMLDocument = SigNode.getOwnerDocument();
	                    }
	                    catch (Exception E)
	                    {
	                        FXMLDocument = new TElXMLDOMDocument();
	                        showErrorMessage("Signed data saving failed. " + E.getMessage());
	                        E.printStackTrace();
	                        return;
	                    }
	                }
	                else
	                {
	                    if (selectedNode == null)
	                    {
	                        showMessage("", "Please, select node for signing.");
	                        return;
	                    }
	
	                    Signer.generateSignature();
	
	                    SigNode = (TElXMLDOMNode)selectedNode;
	                    if (SigNode instanceof TElXMLDOMDocument)
	                        SigNode = ((TElXMLDOMDocument)SigNode).getDocumentElement();
	
	                    try
	                    {
	                        // If the signature type is enveloping, then the signature is placed into the passed node and the contents of the node are moved to inside of the signature. 
	                        // If the signature type is enveloped, the signature is placed as a child of the passed node.
	                    	TSBObject obj = new TSBObject();
	                    	obj.value = SigNode;
	                        Signer.save(obj);
	                    }
	                    catch (Exception E)
	                    {
	                    	E.printStackTrace();
	                        showErrorMessage("Signed data saving failed. " + E.getMessage());
	                        return;
	                    }
	                }
	
	                updateXML();
	            }
	            catch(Exception E) {
	            	E.printStackTrace();
	            	showErrorMessage(E.getMessage());
	            }
	            finally
	            {
	                Signer.Destroy();
	                if (XAdESSigner != null)
	                    XAdESSigner.Destroy();
	                if (TSPClient != null)
	                    TSPClient.Destroy();
	                if (X509KeyData != null)
	                    X509KeyData.Destroy();
	                if (PGPKeyData != null)
	                    PGPKeyData.Destroy();
	            }
	        }	
		}
	}	

	private void LoadCertificate(FileInputStream F, String keyFile, String Password, TElXMLKeyInfoX509Data X509KeyData) {
		int CertFormat;
		X509KeyData.setCertificate(new TElX509Certificate());
		try
		{
			CertFormat = TElX509Certificate.detectCertFileFormat(keyFile);

			switch (CertFormat)
			{
				case SBX509.cfDER: 
				{
					X509KeyData.getCertificate().loadFromStream(F, 0);
					break;
				}
				case SBX509.cfPEM: 
				{
					X509KeyData.getCertificate().loadFromStreamPEM(F, Password, 0);
					break;
				}
				case SBX509.cfPFX: 
				{
					X509KeyData.getCertificate().loadFromStreamPFX(F, Password, 0);
					break;
				}
				default:
				{
					X509KeyData.getCertificate().Free();
					X509KeyData.setCertificate(null);
					break;
				}
			}
		}
		catch (Exception ex)
		{
			X509KeyData.getCertificate().Free();
			X509KeyData.setCertificate(null);
		}
	}

	protected void clear() {
		FXMLDocument.Free();
		FXMLDocument = new TElXMLDOMDocument();
		updateXML();
	}

	protected void deleteSelectedNodes() {
	    DefaultMutableTreeNode node;
	    DefaultTreeModel model = (DefaultTreeModel) (tvXML.getModel());
	    TreePath[] paths = tvXML.getSelectionPaths();
	    for (int i = 0; i < paths.length; i++) {
	      node = (DefaultMutableTreeNode) (paths[i].getLastPathComponent());
	      model.removeNodeFromParent(node);
	    }
	}

	protected void saveXML() {
		TElFileStream F = null;
		try
		{
			F = new TElFileStream(edXMLFile.getText(), "rw", true);
			FXMLDocument.saveToStream(F, SBXMLDefs.xcmNone, "");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
			showErrorMessage(ex.getMessage());
			return;
		}
		if (F != null)
			F.Free();		
	}

	static void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}
	
	static void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}	

	protected void loadXML(String path) {
		TElFileStream F = null;
		try
		{
			F = new TElFileStream(edXMLFile.getText(), "rw", true);
			FXMLDocument.loadFromStream(F);
		}
		catch (Exception e)
		{
			e.printStackTrace();
			showErrorMessage(e.getMessage());
			return;
		}

		if (F != null)
			F.Free();

		updateXML();		
	}

	private void updateXML() {
		mmXML.removeAll();
	
		try {
			rootNode.removeAllChildren();
			updateXMLAddNode(null, FXMLDocument);	
			reloadTree();		
			expandTree();
		} catch (Exception e) {
			e.printStackTrace();
			showErrorMessage(e.getMessage());
		}
	}
    
	private void expandTree() {	
	    int row = 0;
	    while (row < tvXML.getRowCount()) {
	      tvXML.expandRow(row);
	      row++;
	    }
	}
	
	private void reloadTree() {
		TreeModel model = tvXML.getModel();
	    ((DefaultTreeModel) model).reload();
	}

	class NodeData {
		String title;
		TElXMLDOMNode mNode;
		public NodeData(TElXMLDOMNode node, String s) {
			mNode = node;
			title = s;
		}

		public TElXMLDOMNode getNode(){
			return mNode;
		}
		
		public String toString()
		{ 
			return title;
		}
	}
	
	private void updateXMLAddNode(DefaultMutableTreeNode Sibling, TElXMLDOMNode Node)
	{
		TElXMLDOMNode T;
		DefaultMutableTreeNode AttrNode;
		DefaultMutableTreeNode Result;
		TElXMLDOMNamedNodeMap Attributes;
		int i;
		String s;
		if (Node instanceof TElXMLDOMDocument)
			s = ((TElXMLDOMDocument)Node).getLocalName();
		else if (Node instanceof TElXMLDOMElement) 
			s = ((TElXMLDOMElement)Node).getNodeName();
		else if (Node instanceof TElXMLDOMAttr) 
			s = ((TElXMLDOMAttr)Node).getNodeName();
		else
			s = Node.getNodeName();

		DefaultMutableTreeNode Child = new DefaultMutableTreeNode(s);
		Child.setUserObject(new NodeData(Node, s));

		if (Sibling != null)
			Sibling.add(Child);
		else
		{
			DefaultTreeModel model = (DefaultTreeModel) (tvXML.getModel());
			rootNode = Child;
			model.setRoot(Child);
		}
		
		if (Node instanceof TElXMLDOMElement)
		{
			Attributes = ((TElXMLDOMElement)Node).getAttributes();
			if ((Attributes != null) && (Attributes.size() > 0))
			{
				AttrNode = Child;
				for (i = 0; i < Attributes.size(); i++)
					updateXMLAddNode(AttrNode, (TElXMLDOMNode)Attributes.get(i));
			}
		}

		if (Node instanceof TElXMLDOMAttr)
			return;

		T = Node.getFirstChild();
		while (T != null)
		{
			if ((T instanceof TElXMLDOMElement) ||
				(T instanceof TElXMLDOMAttr) ||
				((T instanceof TElXMLDOMText) && (((TElXMLDOMText)T).getNodeValue().trim().length() > 0)))
				updateXMLAddNode(Child, T);

			T = T.getNextSibling();
		}

		return;
	}

	protected String getXMLFileName() {
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	TElXMLDOMNode getFirstNode(TreePath[] paths){
		return ((NodeData)((DefaultMutableTreeNode)paths[0].getLastPathComponent()).getUserObject()).getNode();
	}
	
	void onNodeSelect() {
	    TreePath[] paths = tvXML.getSelectionPaths();

	    if ((paths != null) && (paths.length > 0))
	    {
			TElXMLDOMNode N = getFirstNode(paths);
			String s, nt;
			if (N instanceof TElXMLDOMAttr)
				s = ((TElXMLDOMAttr)N).getNodeValue();
			else
				s = N.getOuterXML();

			lNamespace.setText(N.getNamespaceURI());
			mmXML.setText(s.replace("\n", "\r\n"));
			if (N instanceof TElXMLDOMAttr)
				nt = "Attribute";
			else
				if (N instanceof TElXMLDOMElement)
			{
				if ((N.getParentNode() != null) &&
					!(N.getParentNode() instanceof TElXMLDOMDocument))
					nt = "Element";
				else
					nt = "Root element";
			}
			else
				if (N instanceof TElXMLDOMText) 
				nt = "Text";
			else
				if (N instanceof TElXMLDOMComment)
				nt = "Comment";
			else
				if (N instanceof TElXMLDOMDocument)
				nt = "Document";
			else
				nt = "Unknown";

			lNodeType.setText(nt);
		}
		else
		{
			mmXML.setText("");
			lNodeType.setText("None");
			lNamespace.setText("");
		}		
	}
	
	// event's
	TEnumCharsetsProc.Callback enumClb = new TEnumCharsetsProc.Callback() {
		public boolean tEnumCharsetsProcCallback(String category, String description, String name, String aliases, Object userData) {
            if (!(userData instanceof JComboBox))
                return true;

            @SuppressWarnings("unchecked")
			JComboBox<String> cb = (JComboBox<String>) userData;

            cb.addItem(name);

			return false;
		}
	};
	
	TSBXMLFormatElementEvent.Callback formatElementClb = new TSBXMLFormatElementEvent.Callback() {
		public void tsbxmlFormatElementEventCallback(TObject sender, TElXMLDOMElement elem, int level, String path, TElXMLFormatElementParams params) {
            params.StartTagWhitespace = "\n";
            char tab[] = {'\t'};
            String s = new String(tab);

            params.StartTagWhitespace = params.StartTagWhitespace + s;
            if (elem.getFirstChild() != null)
            {
                boolean HasElements = false;
                TElXMLDOMNode Node = elem.getFirstChild();
                while (Node != null)
                {
                    if (Node.getNodeType() == SBXMLCore.ntElement)
                    {
                        HasElements = true;
                        break;
                    }

                    Node = Node.getNextSibling();
                }

                if (HasElements)
                    params.EndTagWhitespace = "\n" + s;
            }
		}
	};
	
	String createString(char n, int len) {
		StringBuilder sb = new StringBuilder(len);
		while (len-- > 0)
			sb.append(n);
		
		return sb.toString();
	}
	
	TSBXMLFormatTextEvent.Callback formatTextClb = new TSBXMLFormatTextEvent.Callback() {
		
		public String tsbxmlFormatTextEventCallback(TObject sendet, String text,
				short textType, int level, String path) {
            if ((textType == SBXMLDefs.ttBase64) && (text.length() > 64))
            {
                String s = "\n";
                while (text.length() > 0)
                {
                    if (text.length() > 64)
                    {
                        s = s + text.substring(0, 64) + "\n";
                        text = text.substring(64);
                    }
                    else
                    {
                        s = s + text + "\n";
                        text = "";
                    }
                }
                
                text = s + createString('\t', level - 2);
            }
            
            return text;
		}
	};
}