import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import SecureBlackbox.Base.TElX509Certificate;

public class WinCertTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int CERTID_INDEX = 0;
	public static final int ITO_INDEX = 1;
	public static final int IBY_INDEX = 2;
	public static final int VFROM_INDEX = 3;
	public static final int VTO_INDEX = 4;
	public static final int PKEY_INDEX = 5;

	protected Vector<WinCertDataRow> dataVector = new Vector<WinCertDataRow>();
	
    protected String[] columnNames = {
    		"Certificate ID",
    		"Issued To", 
    		"Issued By",
    		"Valid From",
    		"Valid To",
    		"Private Key"
    };
    
    public void addRow(TElX509Certificate cert){
    	dataVector.addElement(new WinCertDataRow(cert));
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        WinCertDataRow record = (WinCertDataRow)dataVector.get(row);
        switch (col) {
        	case CERTID_INDEX:
        		return record.CertID;
        	case ITO_INDEX:
	        	 return record.IssuedTo;
            case IBY_INDEX:
               return record.IssuedBy;
            case VFROM_INDEX:
                return record.ValidFrom;
            case VTO_INDEX:
                return record.ValidTo;
            case PKEY_INDEX:
                return record.PrivateKey;                
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
	}

	public TElX509Certificate getTag(int selectedRow) {
		return dataVector.get(selectedRow).Tag;
	}
}